import json
import pdb


bit_config_dict = {

    "bit_config_resnet50_ILP_3_6_4_test": {

        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.0.quant_linear1": 4,
        "transformer.encoder.layers.0.quant_linear2": 4,

        "transformer.encoder.layers.0.quant_act1": 8,
        "transformer.encoder.layers.0.quant_act2": 8,

        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.1.quant_linear1": 4,
        "transformer.encoder.layers.1.quant_linear2": 4,

        "transformer.encoder.layers.1.quant_act1": 8,
        "transformer.encoder.layers.1.quant_act2": 8,

        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.2.quant_linear1": 4,
        "transformer.encoder.layers.2.quant_linear2": 4,

        "transformer.encoder.layers.2.quant_act1": 8,
        "transformer.encoder.layers.2.quant_act2": 8,

        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.3.quant_linear1": 4,
        "transformer.encoder.layers.3.quant_linear2": 4,

        "transformer.encoder.layers.3.quant_act1": 8,
        "transformer.encoder.layers.3.quant_act2": 8,

        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.4.quant_linear1": 4,
        "transformer.encoder.layers.4.quant_linear2": 4,

        "transformer.encoder.layers.4.quant_act1": 8,
        "transformer.encoder.layers.4.quant_act2": 8,

        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.5.quant_linear1": 4,
        "transformer.encoder.layers.5.quant_linear2": 4,

        "transformer.encoder.layers.5.quant_act1": 8,
        "transformer.encoder.layers.5.quant_act2": 8,

        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 4,

        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.0.quant_act1": 8,
        "transformer.decoder.layers.0.quant_linear1": 4,
        "transformer.decoder.layers.0.quant_act2": 8,
        "transformer.decoder.layers.0.quant_linear2": 4,


        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 4,

        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.1.quant_act1": 8,
        "transformer.decoder.layers.1.quant_linear1": 4,
        "transformer.decoder.layers.1.quant_act2": 8,
        "transformer.decoder.layers.1.quant_linear2": 4,


        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 4,

        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.2.quant_act1": 8,
        "transformer.decoder.layers.2.quant_linear1": 4,
        "transformer.decoder.layers.2.quant_act2": 8,
        "transformer.decoder.layers.2.quant_linear2": 4,

        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 4,

        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.3.quant_act1": 8,
        "transformer.decoder.layers.3.quant_linear1": 4,
        "transformer.decoder.layers.3.quant_act2": 8,
        "transformer.decoder.layers.3.quant_linear2": 4,

        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 4,

        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.4.quant_act1": 8,
        "transformer.decoder.layers.4.quant_linear1": 4,
        "transformer.decoder.layers.4.quant_act2": 8,
        "transformer.decoder.layers.4.quant_linear2": 4,

        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 4,

        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.5.quant_act1": 8,
        "transformer.decoder.layers.5.quant_linear1": 4,
        "transformer.decoder.layers.5.quant_act2": 8,
        "transformer.decoder.layers.5.quant_linear2": 4,

        # 'bbox_embed.quant_act_in':4,
        # 'bbox_embed.quant_linear1':4,
        # 'bbox_embed.quant_act1':4,
        # 'bbox_embed.quant_linear2':4,
        # 'bbox_embed.quant_act2':4,
        # 'bbox_embed.quant_linear3':4,
        #
        # 'class_embed.quant_in':4,
        # 'class_embed.quant_linear':4,

        'input_proj.quant_conv': 4,
        'input_proj.quant_act_in': 4,

        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 4,
        'stage2.unit1.quant_convbn1': 4,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 4,
        'stage2.unit1.quant_convbn3': 4,
        'stage2.unit1.quant_identity_convbn': 4,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 4,
        'stage2.unit4.quant_convbn1': 4,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 4,
        'stage3.unit1.quant_convbn3': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 4,
        'stage4.unit1.quant_convbn3': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 4,
        'stage4.unit3.quant_convbn1': 4,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        # 'quant_act_output': 4,
        # 'quant_output': 4
    },



    "bit_config_resnet50_detrSegm4w0a": {
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_q": 4,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_k": 4,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_v": 4,
        "detr.transformer.encoder.layers.0.quant_self_attn.out_proj": 4,
        "detr.transformer.encoder.layers.0.quant_linear1": 4,
        "detr.transformer.encoder.layers.0.quant_linear2": 4,
        "detr.transformer.encoder.layers.0.quant_act1": 0,
        "detr.transformer.encoder.layers.0.quant_act2": 0,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_q": 4,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_k": 4,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_v": 4,
        "detr.transformer.encoder.layers.1.quant_self_attn.out_proj": 4,
        "detr.transformer.encoder.layers.1.quant_linear1": 4,
        "detr.transformer.encoder.layers.1.quant_linear2": 4,
        "detr.transformer.encoder.layers.1.quant_act1": 0,
        "detr.transformer.encoder.layers.1.quant_act2": 0,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_q": 4,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_k": 4,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_v": 4,
        "detr.transformer.encoder.layers.2.quant_self_attn.out_proj": 4,
        "detr.transformer.encoder.layers.2.quant_linear1": 4,
        "detr.transformer.encoder.layers.2.quant_linear2": 4,
        "detr.transformer.encoder.layers.2.quant_act1": 0,
        "detr.transformer.encoder.layers.2.quant_act2": 0,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_q": 4,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_k": 4,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_v": 4,
        "detr.transformer.encoder.layers.3.quant_self_attn.out_proj": 4,
        "detr.transformer.encoder.layers.3.quant_linear1": 4,
        "detr.transformer.encoder.layers.3.quant_linear2": 4,
        "detr.transformer.encoder.layers.3.quant_act1": 0,
        "detr.transformer.encoder.layers.3.quant_act2": 0,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_q": 4,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_k": 4,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_v": 4,
        "detr.transformer.encoder.layers.4.quant_self_attn.out_proj": 4,
        "detr.transformer.encoder.layers.4.quant_linear1": 4,
        "detr.transformer.encoder.layers.4.quant_linear2": 4,
        "detr.transformer.encoder.layers.4.quant_act1": 0,
        "detr.transformer.encoder.layers.4.quant_act2": 0,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_q": 4,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_k": 4,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_v": 4,
        "detr.transformer.encoder.layers.5.quant_self_attn.out_proj": 4,
        "detr.transformer.encoder.layers.5.quant_linear1": 4,
        "detr.transformer.encoder.layers.5.quant_linear2": 4,
        "detr.transformer.encoder.layers.5.quant_act1": 0,
        "detr.transformer.encoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.0.quant_self_attn.out_proj": 4,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.out_proj": 4,
        "detr.transformer.decoder.layers.0.quant_act1": 0,
        "detr.transformer.decoder.layers.0.quant_linear1": 4,
        "detr.transformer.decoder.layers.0.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_linear2": 4,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.1.quant_self_attn.out_proj": 4,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.out_proj": 4,
        "detr.transformer.decoder.layers.1.quant_act1": 0,
        "detr.transformer.decoder.layers.1.quant_linear1": 4,
        "detr.transformer.decoder.layers.1.quant_act2": 0,
        "detr.transformer.decoder.layers.1.quant_linear2": 4,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.2.quant_self_attn.out_proj": 4,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.out_proj": 4,
        "detr.transformer.decoder.layers.2.quant_act1": 0,
        "detr.transformer.decoder.layers.2.quant_linear1": 4,
        "detr.transformer.decoder.layers.2.quant_act2": 0,
        "detr.transformer.decoder.layers.2.quant_linear2": 4,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.3.quant_self_attn.out_proj": 4,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.out_proj": 4,
        "detr.transformer.decoder.layers.3.quant_act1": 0,
        "detr.transformer.decoder.layers.3.quant_linear1": 4,
        "detr.transformer.decoder.layers.3.quant_act2": 0,
        "detr.transformer.decoder.layers.3.quant_linear2": 4,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.4.quant_self_attn.out_proj": 4,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.out_proj": 4,
        "detr.transformer.decoder.layers.4.quant_act1": 0,
        "detr.transformer.decoder.layers.4.quant_linear1": 4,
        "detr.transformer.decoder.layers.4.quant_act2": 0,
        "detr.transformer.decoder.layers.4.quant_linear2": 4,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.5.quant_self_attn.out_proj": 4,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 4,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 4,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 4,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.out_proj": 4,
        "detr.transformer.decoder.layers.5.quant_act1": 0,
        "detr.transformer.decoder.layers.5.quant_linear1": 4,
        "detr.transformer.decoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.5.quant_linear2": 4,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 4,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 4,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 4,
        "class_embed.quant_in": 4,
        "class_embed.quant_linear": 4,
        "detr.input_proj.quant_conv": 4,
        "detr.input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 4,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 4,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 4,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 4,
        "stage1.unit1.quant_identity_convbn": 4,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 4,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 4,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 4,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 4,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 4,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 4,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 4,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 4,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 4,
        "stage2.unit1.quant_identity_convbn": 4,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 4,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 4,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 4,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 4,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 4,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 4,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 4,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 4,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 4,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 4,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 4,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 4,
        "stage3.unit1.quant_identity_convbn": 4,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 4,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 4,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 4,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 4,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 4,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 4,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 4,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 4,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 4,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 4,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 4,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 4,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 4,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 4,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 4,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 4,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 4,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 4,
        "stage4.unit1.quant_identity_convbn": 4,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 4,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 4,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 4,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 4,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 4,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 4,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 4,
        "bbox_attention.quant_act_in_k": 0,
        "bbox_attention.quant_dropout": 4,
        "bbox_attention.quant_q_linear": 4,
        "bbox_attention.quant_k_linear": 4,
        "mask_head.quant_act_in": 0,
        "mask_head.quant_lay1": 4,
        "mask_head.quant_gn1": 4,
        "mask_head.quant_act1": 0,
        "mask_head.quant_lay2": 4,
        "mask_head.quant_gn2": 4,
        "mask_head.quant_act2": 0,
        "mask_head.quant_lay3": 4,
        "mask_head.quant_gn3": 4,
        "mask_head.quant_act3": 0,
        "mask_head.quant_lay4": 4,
        "mask_head.quant_gn4": 4,
        "mask_head.quant_act4": 0,
        "mask_head.quant_lay5": 4,
        "mask_head.quant_gn5": 4,
        "mask_head.quant_act_out": 0,
        "mask_head.quant_out_lay": 4,
        "mask_head.quant_act5": 0,
        "mask_head.quant_adapter1": 4,
        "mask_head.quant_act6": 0,
        "mask_head.quant_adapter2": 4,
        "mask_head.quant_act7": 0,
        "mask_head.quant_adapter3": 4
    },



    "bit_config_resnet50_detrSegm5w0a": {
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_q": 5,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_k": 5,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_v": 5,
        "detr.transformer.encoder.layers.0.quant_self_attn.out_proj": 5,
        "detr.transformer.encoder.layers.0.quant_linear1": 5,
        "detr.transformer.encoder.layers.0.quant_linear2": 5,
        "detr.transformer.encoder.layers.0.quant_act1": 0,
        "detr.transformer.encoder.layers.0.quant_act2": 0,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_q": 5,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_k": 5,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_v": 5,
        "detr.transformer.encoder.layers.1.quant_self_attn.out_proj": 5,
        "detr.transformer.encoder.layers.1.quant_linear1": 5,
        "detr.transformer.encoder.layers.1.quant_linear2": 5,
        "detr.transformer.encoder.layers.1.quant_act1": 0,
        "detr.transformer.encoder.layers.1.quant_act2": 0,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_q": 5,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_k": 5,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_v": 5,
        "detr.transformer.encoder.layers.2.quant_self_attn.out_proj": 5,
        "detr.transformer.encoder.layers.2.quant_linear1": 5,
        "detr.transformer.encoder.layers.2.quant_linear2": 5,
        "detr.transformer.encoder.layers.2.quant_act1": 0,
        "detr.transformer.encoder.layers.2.quant_act2": 0,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_q": 5,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_k": 5,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_v": 5,
        "detr.transformer.encoder.layers.3.quant_self_attn.out_proj": 5,
        "detr.transformer.encoder.layers.3.quant_linear1": 5,
        "detr.transformer.encoder.layers.3.quant_linear2": 5,
        "detr.transformer.encoder.layers.3.quant_act1": 0,
        "detr.transformer.encoder.layers.3.quant_act2": 0,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_q": 5,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_k": 5,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_v": 5,
        "detr.transformer.encoder.layers.4.quant_self_attn.out_proj": 5,
        "detr.transformer.encoder.layers.4.quant_linear1": 5,
        "detr.transformer.encoder.layers.4.quant_linear2": 5,
        "detr.transformer.encoder.layers.4.quant_act1": 0,
        "detr.transformer.encoder.layers.4.quant_act2": 0,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_q": 5,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_k": 5,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_v": 5,
        "detr.transformer.encoder.layers.5.quant_self_attn.out_proj": 5,
        "detr.transformer.encoder.layers.5.quant_linear1": 5,
        "detr.transformer.encoder.layers.5.quant_linear2": 5,
        "detr.transformer.encoder.layers.5.quant_act1": 0,
        "detr.transformer.encoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.0.quant_self_attn.out_proj": 5,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.out_proj": 5,
        "detr.transformer.decoder.layers.0.quant_act1": 0,
        "detr.transformer.decoder.layers.0.quant_linear1": 5,
        "detr.transformer.decoder.layers.0.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_linear2": 5,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.1.quant_self_attn.out_proj": 5,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.out_proj": 5,
        "detr.transformer.decoder.layers.1.quant_act1": 0,
        "detr.transformer.decoder.layers.1.quant_linear1": 5,
        "detr.transformer.decoder.layers.1.quant_act2": 0,
        "detr.transformer.decoder.layers.1.quant_linear2": 5,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.2.quant_self_attn.out_proj": 5,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.out_proj": 5,
        "detr.transformer.decoder.layers.2.quant_act1": 0,
        "detr.transformer.decoder.layers.2.quant_linear1": 5,
        "detr.transformer.decoder.layers.2.quant_act2": 0,
        "detr.transformer.decoder.layers.2.quant_linear2": 5,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.3.quant_self_attn.out_proj": 5,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.out_proj": 5,
        "detr.transformer.decoder.layers.3.quant_act1": 0,
        "detr.transformer.decoder.layers.3.quant_linear1": 5,
        "detr.transformer.decoder.layers.3.quant_act2": 0,
        "detr.transformer.decoder.layers.3.quant_linear2": 5,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.4.quant_self_attn.out_proj": 5,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.out_proj": 5,
        "detr.transformer.decoder.layers.4.quant_act1": 0,
        "detr.transformer.decoder.layers.4.quant_linear1": 5,
        "detr.transformer.decoder.layers.4.quant_act2": 0,
        "detr.transformer.decoder.layers.4.quant_linear2": 5,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.5.quant_self_attn.out_proj": 5,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 5,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 5,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 5,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.out_proj": 5,
        "detr.transformer.decoder.layers.5.quant_act1": 0,
        "detr.transformer.decoder.layers.5.quant_linear1": 5,
        "detr.transformer.decoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.5.quant_linear2": 5,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 5,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 5,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 5,
        "class_embed.quant_in": 5,
        "class_embed.quant_linear": 5,
        "detr.input_proj.quant_conv": 5,
        "detr.input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 5,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 5,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 5,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 5,
        "stage1.unit1.quant_identity_convbn": 5,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 5,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 5,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 5,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 5,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 5,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 5,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 5,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 5,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 5,
        "stage2.unit1.quant_identity_convbn": 5,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 5,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 5,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 5,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 5,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 5,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 5,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 5,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 5,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 5,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 5,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 5,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 5,
        "stage3.unit1.quant_identity_convbn": 5,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 5,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 5,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 5,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 5,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 5,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 5,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 5,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 5,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 5,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 5,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 5,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 5,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 5,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 5,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 5,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 5,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 5,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 5,
        "stage4.unit1.quant_identity_convbn": 5,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 5,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 5,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 5,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 5,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 5,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 5,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 5,
        "bbox_attention.quant_act_in_k": 0,
        "bbox_attention.quant_dropout": 5,
        "bbox_attention.quant_q_linear": 5,
        "bbox_attention.quant_k_linear": 5,
        "mask_head.quant_act_in": 0,
        "mask_head.quant_lay1": 5,
        "mask_head.quant_gn1": 5,
        "mask_head.quant_act1": 0,
        "mask_head.quant_lay2": 5,
        "mask_head.quant_gn2": 5,
        "mask_head.quant_act2": 0,
        "mask_head.quant_lay3": 5,
        "mask_head.quant_gn3": 5,
        "mask_head.quant_act3": 0,
        "mask_head.quant_lay4": 5,
        "mask_head.quant_gn4": 5,
        "mask_head.quant_act4": 0,
        "mask_head.quant_lay5": 5,
        "mask_head.quant_gn5": 5,
        "mask_head.quant_act_out": 0,
        "mask_head.quant_out_lay": 5,
        "mask_head.quant_act5": 0,
        "mask_head.quant_adapter1": 5,
        "mask_head.quant_act6": 0,
        "mask_head.quant_adapter2": 5,
        "mask_head.quant_act7": 0,
        "mask_head.quant_adapter3": 8
    },



    "bit_config_resnet50_detrSegm6w0a": {
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_q": 6,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_k": 6,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_v": 6,
        "detr.transformer.encoder.layers.0.quant_self_attn.out_proj": 6,
        "detr.transformer.encoder.layers.0.quant_linear1": 6,
        "detr.transformer.encoder.layers.0.quant_linear2": 6,
        "detr.transformer.encoder.layers.0.quant_act1": 0,
        "detr.transformer.encoder.layers.0.quant_act2": 0,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_q": 6,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_k": 6,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_v": 6,
        "detr.transformer.encoder.layers.1.quant_self_attn.out_proj": 6,
        "detr.transformer.encoder.layers.1.quant_linear1": 6,
        "detr.transformer.encoder.layers.1.quant_linear2": 6,
        "detr.transformer.encoder.layers.1.quant_act1": 0,
        "detr.transformer.encoder.layers.1.quant_act2": 0,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_q": 6,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_k": 6,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_v": 6,
        "detr.transformer.encoder.layers.2.quant_self_attn.out_proj": 6,
        "detr.transformer.encoder.layers.2.quant_linear1": 6,
        "detr.transformer.encoder.layers.2.quant_linear2": 6,
        "detr.transformer.encoder.layers.2.quant_act1": 0,
        "detr.transformer.encoder.layers.2.quant_act2": 0,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_q": 6,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_k": 6,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_v": 6,
        "detr.transformer.encoder.layers.3.quant_self_attn.out_proj": 6,
        "detr.transformer.encoder.layers.3.quant_linear1": 6,
        "detr.transformer.encoder.layers.3.quant_linear2": 6,
        "detr.transformer.encoder.layers.3.quant_act1": 0,
        "detr.transformer.encoder.layers.3.quant_act2": 0,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_q": 6,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_k": 6,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_v": 6,
        "detr.transformer.encoder.layers.4.quant_self_attn.out_proj": 6,
        "detr.transformer.encoder.layers.4.quant_linear1": 6,
        "detr.transformer.encoder.layers.4.quant_linear2": 6,
        "detr.transformer.encoder.layers.4.quant_act1": 0,
        "detr.transformer.encoder.layers.4.quant_act2": 0,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_q": 6,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_k": 6,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_v": 6,
        "detr.transformer.encoder.layers.5.quant_self_attn.out_proj": 6,
        "detr.transformer.encoder.layers.5.quant_linear1": 6,
        "detr.transformer.encoder.layers.5.quant_linear2": 6,
        "detr.transformer.encoder.layers.5.quant_act1": 0,
        "detr.transformer.encoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.0.quant_self_attn.out_proj": 6,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.out_proj": 6,
        "detr.transformer.decoder.layers.0.quant_act1": 0,
        "detr.transformer.decoder.layers.0.quant_linear1": 6,
        "detr.transformer.decoder.layers.0.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_linear2": 6,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.1.quant_self_attn.out_proj": 6,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.out_proj": 6,
        "detr.transformer.decoder.layers.1.quant_act1": 0,
        "detr.transformer.decoder.layers.1.quant_linear1": 6,
        "detr.transformer.decoder.layers.1.quant_act2": 0,
        "detr.transformer.decoder.layers.1.quant_linear2": 6,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.2.quant_self_attn.out_proj": 6,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.out_proj": 6,
        "detr.transformer.decoder.layers.2.quant_act1": 0,
        "detr.transformer.decoder.layers.2.quant_linear1": 6,
        "detr.transformer.decoder.layers.2.quant_act2": 0,
        "detr.transformer.decoder.layers.2.quant_linear2": 6,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.3.quant_self_attn.out_proj": 6,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.out_proj": 6,
        "detr.transformer.decoder.layers.3.quant_act1": 0,
        "detr.transformer.decoder.layers.3.quant_linear1": 6,
        "detr.transformer.decoder.layers.3.quant_act2": 0,
        "detr.transformer.decoder.layers.3.quant_linear2": 6,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.4.quant_self_attn.out_proj": 6,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.out_proj": 6,
        "detr.transformer.decoder.layers.4.quant_act1": 0,
        "detr.transformer.decoder.layers.4.quant_linear1": 6,
        "detr.transformer.decoder.layers.4.quant_act2": 0,
        "detr.transformer.decoder.layers.4.quant_linear2": 6,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.5.quant_self_attn.out_proj": 6,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 6,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 6,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 6,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.out_proj": 6,
        "detr.transformer.decoder.layers.5.quant_act1": 0,
        "detr.transformer.decoder.layers.5.quant_linear1": 6,
        "detr.transformer.decoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.5.quant_linear2": 6,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 6,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 6,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 6,
        "class_embed.quant_in": 6,
        "class_embed.quant_linear": 6,
        "detr.input_proj.quant_conv": 6,
        "detr.input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 6,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 6,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 6,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 6,
        "stage1.unit1.quant_identity_convbn": 6,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 6,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 6,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 6,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 6,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 6,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 6,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 6,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 6,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 6,
        "stage2.unit1.quant_identity_convbn": 6,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 6,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 6,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 6,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 6,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 6,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 6,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 6,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 6,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 6,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 6,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 6,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 6,
        "stage3.unit1.quant_identity_convbn": 6,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 6,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 6,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 6,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 6,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 6,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 6,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 6,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 6,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 6,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 6,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 6,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 6,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 6,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 6,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 6,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 6,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 6,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 6,
        "stage4.unit1.quant_identity_convbn": 6,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 6,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 6,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 6,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 6,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 6,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 6,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 6,
        "bbox_attention.quant_act_in_k": 0,
        "bbox_attention.quant_dropout": 6,
        "bbox_attention.quant_q_linear": 6,
        "bbox_attention.quant_k_linear": 6,
        "mask_head.quant_act_in": 0,
        "mask_head.quant_lay1": 6,
        "mask_head.quant_gn1": 6,
        "mask_head.quant_act1": 0,
        "mask_head.quant_lay2": 6,
        "mask_head.quant_gn2": 6,
        "mask_head.quant_act2": 0,
        "mask_head.quant_lay3": 6,
        "mask_head.quant_gn3": 6,
        "mask_head.quant_act3": 0,
        "mask_head.quant_lay4": 6,
        "mask_head.quant_gn4": 6,
        "mask_head.quant_act4": 0,
        "mask_head.quant_lay5": 6,
        "mask_head.quant_gn5": 6,
        "mask_head.quant_act_out": 0,
        "mask_head.quant_out_lay": 6,
        "mask_head.quant_act5": 0,
        "mask_head.quant_adapter1": 6,
        "mask_head.quant_act6": 0,
        "mask_head.quant_adapter2": 6,
        "mask_head.quant_act7": 0,
        "mask_head.quant_adapter3": 6
    },



    "bit_config_resnet50_detrSegm8w0a": {
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_q": 8,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_k": 8,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_v": 8,
        "detr.transformer.encoder.layers.0.quant_self_attn.out_proj": 8,
        "detr.transformer.encoder.layers.0.quant_linear1": 8,
        "detr.transformer.encoder.layers.0.quant_linear2": 8,
        "detr.transformer.encoder.layers.0.quant_act1": 0,
        "detr.transformer.encoder.layers.0.quant_act2": 0,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_q": 8,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_k": 8,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_v": 8,
        "detr.transformer.encoder.layers.1.quant_self_attn.out_proj": 8,
        "detr.transformer.encoder.layers.1.quant_linear1": 8,
        "detr.transformer.encoder.layers.1.quant_linear2": 8,
        "detr.transformer.encoder.layers.1.quant_act1": 0,
        "detr.transformer.encoder.layers.1.quant_act2": 0,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_q": 8,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_k": 8,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_v": 8,
        "detr.transformer.encoder.layers.2.quant_self_attn.out_proj": 8,
        "detr.transformer.encoder.layers.2.quant_linear1": 8,
        "detr.transformer.encoder.layers.2.quant_linear2": 8,
        "detr.transformer.encoder.layers.2.quant_act1": 0,
        "detr.transformer.encoder.layers.2.quant_act2": 0,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_q": 8,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_k": 8,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_v": 8,
        "detr.transformer.encoder.layers.3.quant_self_attn.out_proj": 8,
        "detr.transformer.encoder.layers.3.quant_linear1": 8,
        "detr.transformer.encoder.layers.3.quant_linear2": 8,
        "detr.transformer.encoder.layers.3.quant_act1": 0,
        "detr.transformer.encoder.layers.3.quant_act2": 0,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_q": 8,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_k": 8,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_v": 8,
        "detr.transformer.encoder.layers.4.quant_self_attn.out_proj": 8,
        "detr.transformer.encoder.layers.4.quant_linear1": 8,
        "detr.transformer.encoder.layers.4.quant_linear2": 8,
        "detr.transformer.encoder.layers.4.quant_act1": 0,
        "detr.transformer.encoder.layers.4.quant_act2": 0,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_q": 8,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_k": 8,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_v": 8,
        "detr.transformer.encoder.layers.5.quant_self_attn.out_proj": 8,
        "detr.transformer.encoder.layers.5.quant_linear1": 8,
        "detr.transformer.encoder.layers.5.quant_linear2": 8,
        "detr.transformer.encoder.layers.5.quant_act1": 0,
        "detr.transformer.encoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.0.quant_self_attn.out_proj": 8,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.out_proj": 8,
        "detr.transformer.decoder.layers.0.quant_act1": 0,
        "detr.transformer.decoder.layers.0.quant_linear1": 8,
        "detr.transformer.decoder.layers.0.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_linear2": 8,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.1.quant_self_attn.out_proj": 8,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.out_proj": 8,
        "detr.transformer.decoder.layers.1.quant_act1": 0,
        "detr.transformer.decoder.layers.1.quant_linear1": 8,
        "detr.transformer.decoder.layers.1.quant_act2": 0,
        "detr.transformer.decoder.layers.1.quant_linear2": 8,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.2.quant_self_attn.out_proj": 8,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.out_proj": 8,
        "detr.transformer.decoder.layers.2.quant_act1": 0,
        "detr.transformer.decoder.layers.2.quant_linear1": 8,
        "detr.transformer.decoder.layers.2.quant_act2": 0,
        "detr.transformer.decoder.layers.2.quant_linear2": 8,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.3.quant_self_attn.out_proj": 8,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.out_proj": 8,
        "detr.transformer.decoder.layers.3.quant_act1": 0,
        "detr.transformer.decoder.layers.3.quant_linear1": 8,
        "detr.transformer.decoder.layers.3.quant_act2": 0,
        "detr.transformer.decoder.layers.3.quant_linear2": 8,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.4.quant_self_attn.out_proj": 8,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.out_proj": 8,
        "detr.transformer.decoder.layers.4.quant_act1": 0,
        "detr.transformer.decoder.layers.4.quant_linear1": 8,
        "detr.transformer.decoder.layers.4.quant_act2": 0,
        "detr.transformer.decoder.layers.4.quant_linear2": 8,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.5.quant_self_attn.out_proj": 8,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 8,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 8,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 8,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.out_proj": 8,
        "detr.transformer.decoder.layers.5.quant_act1": 0,
        "detr.transformer.decoder.layers.5.quant_linear1": 8,
        "detr.transformer.decoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.5.quant_linear2": 8,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 8,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 8,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 8,
        "class_embed.quant_in": 8,
        "class_embed.quant_linear": 8,
        "detr.input_proj.quant_conv": 8,
        "detr.input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 8,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 8,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 8,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 8,
        "stage1.unit1.quant_identity_convbn": 8,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 8,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 8,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 8,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 8,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 8,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 8,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 8,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 8,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 8,
        "stage2.unit1.quant_identity_convbn": 8,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 8,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 8,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 8,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 8,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 8,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 8,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 8,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 8,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 8,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 8,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 8,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 8,
        "stage3.unit1.quant_identity_convbn": 8,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 8,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 8,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 8,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 8,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 8,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 8,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 8,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 8,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 8,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 8,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 8,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 8,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 8,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 8,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 8,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 8,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 8,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 8,
        "stage4.unit1.quant_identity_convbn": 8,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 8,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 8,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 8,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 8,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 8,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 8,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 8,
        "bbox_attention.quant_act_in_k": 0,
        "bbox_attention.quant_dropout": 8,
        "bbox_attention.quant_q_linear": 8,
        "bbox_attention.quant_k_linear": 8,
        "mask_head.quant_act_in": 0,
        "mask_head.quant_lay1": 8,
        "mask_head.quant_gn1": 8,
        "mask_head.quant_act1": 0,
        "mask_head.quant_lay2": 8,
        "mask_head.quant_gn2": 8,
        "mask_head.quant_act2": 0,
        "mask_head.quant_lay3": 8,
        "mask_head.quant_gn3": 8,
        "mask_head.quant_act3": 0,
        "mask_head.quant_lay4": 8,
        "mask_head.quant_gn4": 8,
        "mask_head.quant_act4": 0,
        "mask_head.quant_lay5": 8,
        "mask_head.quant_gn5": 8,
        "mask_head.quant_act_out": 0,
        "mask_head.quant_out_lay": 8,
        "mask_head.quant_act5": 0,
        "mask_head.quant_adapter1": 8,
        "mask_head.quant_act6": 0,
        "mask_head.quant_adapter2": 8,
        "mask_head.quant_act7": 0,
        "mask_head.quant_adapter3": 8
    },



    "bit_config_resnet50_detrSegm16w0a": {
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_q": 16,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_k": 16,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_v": 16,
        "detr.transformer.encoder.layers.0.quant_self_attn.out_proj": 16,
        "detr.transformer.encoder.layers.0.quant_linear1": 16,
        "detr.transformer.encoder.layers.0.quant_linear2": 16,
        "detr.transformer.encoder.layers.0.quant_act1": 0,
        "detr.transformer.encoder.layers.0.quant_act2": 0,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_q": 16,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_k": 16,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_v": 16,
        "detr.transformer.encoder.layers.1.quant_self_attn.out_proj": 16,
        "detr.transformer.encoder.layers.1.quant_linear1": 16,
        "detr.transformer.encoder.layers.1.quant_linear2": 16,
        "detr.transformer.encoder.layers.1.quant_act1": 0,
        "detr.transformer.encoder.layers.1.quant_act2": 0,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_q": 16,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_k": 16,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_v": 16,
        "detr.transformer.encoder.layers.2.quant_self_attn.out_proj": 16,
        "detr.transformer.encoder.layers.2.quant_linear1": 16,
        "detr.transformer.encoder.layers.2.quant_linear2": 16,
        "detr.transformer.encoder.layers.2.quant_act1": 0,
        "detr.transformer.encoder.layers.2.quant_act2": 0,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_q": 16,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_k": 16,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_v": 16,
        "detr.transformer.encoder.layers.3.quant_self_attn.out_proj": 16,
        "detr.transformer.encoder.layers.3.quant_linear1": 16,
        "detr.transformer.encoder.layers.3.quant_linear2": 16,
        "detr.transformer.encoder.layers.3.quant_act1": 0,
        "detr.transformer.encoder.layers.3.quant_act2": 0,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_q": 16,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_k": 16,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_v": 16,
        "detr.transformer.encoder.layers.4.quant_self_attn.out_proj": 16,
        "detr.transformer.encoder.layers.4.quant_linear1": 16,
        "detr.transformer.encoder.layers.4.quant_linear2": 16,
        "detr.transformer.encoder.layers.4.quant_act1": 0,
        "detr.transformer.encoder.layers.4.quant_act2": 0,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_q": 16,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_k": 16,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_v": 16,
        "detr.transformer.encoder.layers.5.quant_self_attn.out_proj": 16,
        "detr.transformer.encoder.layers.5.quant_linear1": 16,
        "detr.transformer.encoder.layers.5.quant_linear2": 16,
        "detr.transformer.encoder.layers.5.quant_act1": 0,
        "detr.transformer.encoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.0.quant_self_attn.out_proj": 16,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.out_proj": 16,
        "detr.transformer.decoder.layers.0.quant_act1": 0,
        "detr.transformer.decoder.layers.0.quant_linear1": 16,
        "detr.transformer.decoder.layers.0.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_linear2": 16,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.1.quant_self_attn.out_proj": 16,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.out_proj": 16,
        "detr.transformer.decoder.layers.1.quant_act1": 0,
        "detr.transformer.decoder.layers.1.quant_linear1": 16,
        "detr.transformer.decoder.layers.1.quant_act2": 0,
        "detr.transformer.decoder.layers.1.quant_linear2": 16,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.2.quant_self_attn.out_proj": 16,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.out_proj": 16,
        "detr.transformer.decoder.layers.2.quant_act1": 0,
        "detr.transformer.decoder.layers.2.quant_linear1": 16,
        "detr.transformer.decoder.layers.2.quant_act2": 0,
        "detr.transformer.decoder.layers.2.quant_linear2": 16,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.3.quant_self_attn.out_proj": 16,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.out_proj": 16,
        "detr.transformer.decoder.layers.3.quant_act1": 0,
        "detr.transformer.decoder.layers.3.quant_linear1": 16,
        "detr.transformer.decoder.layers.3.quant_act2": 0,
        "detr.transformer.decoder.layers.3.quant_linear2": 16,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.4.quant_self_attn.out_proj": 16,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.out_proj": 16,
        "detr.transformer.decoder.layers.4.quant_act1": 0,
        "detr.transformer.decoder.layers.4.quant_linear1": 16,
        "detr.transformer.decoder.layers.4.quant_act2": 0,
        "detr.transformer.decoder.layers.4.quant_linear2": 16,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.5.quant_self_attn.out_proj": 16,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 16,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 16,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 16,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.out_proj": 16,
        "detr.transformer.decoder.layers.5.quant_act1": 0,
        "detr.transformer.decoder.layers.5.quant_linear1": 16,
        "detr.transformer.decoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.5.quant_linear2": 16,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 16,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 16,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 16,
        "class_embed.quant_in": 16,
        "class_embed.quant_linear": 16,
        "detr.input_proj.quant_conv": 16,
        "detr.input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 16,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 16,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 16,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 16,
        "stage1.unit1.quant_identity_convbn": 16,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 16,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 16,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 16,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 16,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 16,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 16,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 16,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 16,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 16,
        "stage2.unit1.quant_identity_convbn": 16,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 16,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 16,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 16,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 16,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 16,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 16,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 16,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 16,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 16,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 16,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 16,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 16,
        "stage3.unit1.quant_identity_convbn": 16,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 16,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 16,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 16,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 16,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 16,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 16,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 16,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 16,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 16,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 16,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 16,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 16,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 16,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 16,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 16,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 16,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 16,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 16,
        "stage4.unit1.quant_identity_convbn": 16,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 16,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 16,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 16,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 16,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 16,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 16,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 16,
        "bbox_attention.quant_act_in_k": 0,
        "bbox_attention.quant_dropout": 16,
        "bbox_attention.quant_q_linear": 16,
        "bbox_attention.quant_k_linear": 16,
        "mask_head.quant_act_in": 0,
        "mask_head.quant_lay1": 16,
        "mask_head.quant_gn1": 16,
        "mask_head.quant_act1": 0,
        "mask_head.quant_lay2": 16,
        "mask_head.quant_gn2": 16,
        "mask_head.quant_act2": 0,
        "mask_head.quant_lay3": 16,
        "mask_head.quant_gn3": 16,
        "mask_head.quant_act3": 0,
        "mask_head.quant_lay4": 16,
        "mask_head.quant_gn4": 16,
        "mask_head.quant_act4": 0,
        "mask_head.quant_lay5": 16,
        "mask_head.quant_gn5": 16,
        "mask_head.quant_act_out": 0,
        "mask_head.quant_out_lay": 16,
        "mask_head.quant_act5": 0,
        "mask_head.quant_adapter1": 16,
        "mask_head.quant_act6": 0,
        "mask_head.quant_adapter2": 16,
        "mask_head.quant_act7": 0,
        "mask_head.quant_adapter3": 16
    },


    "bit_config_resnet50_detrSegm32w0a": {
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_q": 32,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_k": 32,
        "detr.transformer.encoder.layers.0.quant_self_attn.in_proj_v": 32,
        "detr.transformer.encoder.layers.0.quant_self_attn.out_proj": 32,
        "detr.transformer.encoder.layers.0.quant_linear1": 32,
        "detr.transformer.encoder.layers.0.quant_linear2": 32,
        "detr.transformer.encoder.layers.0.quant_act1": 0,
        "detr.transformer.encoder.layers.0.quant_act2": 0,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_q": 32,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_k": 32,
        "detr.transformer.encoder.layers.1.quant_self_attn.in_proj_v": 32,
        "detr.transformer.encoder.layers.1.quant_self_attn.out_proj": 32,
        "detr.transformer.encoder.layers.1.quant_linear1": 32,
        "detr.transformer.encoder.layers.1.quant_linear2": 32,
        "detr.transformer.encoder.layers.1.quant_act1": 0,
        "detr.transformer.encoder.layers.1.quant_act2": 0,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_q": 32,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_k": 32,
        "detr.transformer.encoder.layers.2.quant_self_attn.in_proj_v": 32,
        "detr.transformer.encoder.layers.2.quant_self_attn.out_proj": 32,
        "detr.transformer.encoder.layers.2.quant_linear1": 32,
        "detr.transformer.encoder.layers.2.quant_linear2": 32,
        "detr.transformer.encoder.layers.2.quant_act1": 0,
        "detr.transformer.encoder.layers.2.quant_act2": 0,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_q": 32,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_k": 32,
        "detr.transformer.encoder.layers.3.quant_self_attn.in_proj_v": 32,
        "detr.transformer.encoder.layers.3.quant_self_attn.out_proj": 32,
        "detr.transformer.encoder.layers.3.quant_linear1": 32,
        "detr.transformer.encoder.layers.3.quant_linear2": 32,
        "detr.transformer.encoder.layers.3.quant_act1": 0,
        "detr.transformer.encoder.layers.3.quant_act2": 0,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_q": 32,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_k": 32,
        "detr.transformer.encoder.layers.4.quant_self_attn.in_proj_v": 32,
        "detr.transformer.encoder.layers.4.quant_self_attn.out_proj": 32,
        "detr.transformer.encoder.layers.4.quant_linear1": 32,
        "detr.transformer.encoder.layers.4.quant_linear2": 32,
        "detr.transformer.encoder.layers.4.quant_act1": 0,
        "detr.transformer.encoder.layers.4.quant_act2": 0,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_q": 32,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_k": 32,
        "detr.transformer.encoder.layers.5.quant_self_attn.in_proj_v": 32,
        "detr.transformer.encoder.layers.5.quant_self_attn.out_proj": 32,
        "detr.transformer.encoder.layers.5.quant_linear1": 32,
        "detr.transformer.encoder.layers.5.quant_linear2": 32,
        "detr.transformer.encoder.layers.5.quant_act1": 0,
        "detr.transformer.encoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.0.quant_self_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.0.quant_self_attn.out_proj": 32,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.0.quant_multihead_attn.out_proj": 32,
        "detr.transformer.decoder.layers.0.quant_act1": 0,
        "detr.transformer.decoder.layers.0.quant_linear1": 32,
        "detr.transformer.decoder.layers.0.quant_act2": 0,
        "detr.transformer.decoder.layers.0.quant_linear2": 32,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.1.quant_self_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.1.quant_self_attn.out_proj": 32,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.1.quant_multihead_attn.out_proj": 32,
        "detr.transformer.decoder.layers.1.quant_act1": 0,
        "detr.transformer.decoder.layers.1.quant_linear1": 32,
        "detr.transformer.decoder.layers.1.quant_act2": 0,
        "detr.transformer.decoder.layers.1.quant_linear2": 32,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.2.quant_self_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.2.quant_self_attn.out_proj": 32,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.2.quant_multihead_attn.out_proj": 32,
        "detr.transformer.decoder.layers.2.quant_act1": 0,
        "detr.transformer.decoder.layers.2.quant_linear1": 32,
        "detr.transformer.decoder.layers.2.quant_act2": 0,
        "detr.transformer.decoder.layers.2.quant_linear2": 32,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.3.quant_self_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.3.quant_self_attn.out_proj": 32,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.3.quant_multihead_attn.out_proj": 32,
        "detr.transformer.decoder.layers.3.quant_act1": 0,
        "detr.transformer.decoder.layers.3.quant_linear1": 32,
        "detr.transformer.decoder.layers.3.quant_act2": 0,
        "detr.transformer.decoder.layers.3.quant_linear2": 32,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.4.quant_self_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.4.quant_self_attn.out_proj": 32,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.4.quant_multihead_attn.out_proj": 32,
        "detr.transformer.decoder.layers.4.quant_act1": 0,
        "detr.transformer.decoder.layers.4.quant_linear1": 32,
        "detr.transformer.decoder.layers.4.quant_act2": 0,
        "detr.transformer.decoder.layers.4.quant_linear2": 32,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.5.quant_self_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.5.quant_self_attn.out_proj": 32,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 32,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 32,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 32,
        "detr.transformer.decoder.layers.5.quant_multihead_attn.out_proj": 32,
        "detr.transformer.decoder.layers.5.quant_act1": 0,
        "detr.transformer.decoder.layers.5.quant_linear1": 32,
        "detr.transformer.decoder.layers.5.quant_act2": 0,
        "detr.transformer.decoder.layers.5.quant_linear2": 32,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 32,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 32,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 32,
        "class_embed.quant_in": 32,
        "class_embed.quant_linear": 32,
        "detr.input_proj.quant_conv": 32,
        "detr.input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 32,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 32,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 32,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 32,
        "stage1.unit1.quant_identity_convbn": 32,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 32,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 32,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 32,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 32,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 32,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 32,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 32,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 32,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 32,
        "stage2.unit1.quant_identity_convbn": 32,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 32,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 32,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 32,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 32,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 32,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 32,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 32,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 32,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 32,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 32,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 32,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 32,
        "stage3.unit1.quant_identity_convbn": 32,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 32,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 32,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 32,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 32,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 32,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 32,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 32,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 32,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 32,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 32,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 32,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 32,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 32,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 32,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 32,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 32,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 32,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 32,
        "stage4.unit1.quant_identity_convbn": 32,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 32,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 32,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 32,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 32,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 32,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 32,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 32,
        "bbox_attention.quant_act_in_k": 0,
        "bbox_attention.quant_dropout": 32,
        "bbox_attention.quant_q_linear": 32,
        "bbox_attention.quant_k_linear": 32,
        "mask_head.quant_act_in": 0,
        "mask_head.quant_lay1": 32,
        "mask_head.quant_gn1": 32,
        "mask_head.quant_act1": 0,
        "mask_head.quant_lay2": 32,
        "mask_head.quant_gn2": 32,
        "mask_head.quant_act2": 0,
        "mask_head.quant_lay3": 32,
        "mask_head.quant_gn3": 32,
        "mask_head.quant_act3": 0,
        "mask_head.quant_lay4": 32,
        "mask_head.quant_gn4": 32,
        "mask_head.quant_act4": 0,
        "mask_head.quant_lay5": 32,
        "mask_head.quant_gn5": 32,
        "mask_head.quant_act_out": 0,
        "mask_head.quant_out_lay": 32,
        "mask_head.quant_act5": 0,
        "mask_head.quant_adapter1": 32,
        "mask_head.quant_act6": 0,
        "mask_head.quant_adapter2": 32,
        "mask_head.quant_act7": 0,
        "mask_head.quant_adapter3": 32
    },


    "bit_config_resnet50_detr8w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.0.quant_linear1": 8,
        "transformer.encoder.layers.0.quant_linear2": 8,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.1.quant_linear1": 8,
        "transformer.encoder.layers.1.quant_linear2": 8,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.2.quant_linear1": 8,
        "transformer.encoder.layers.2.quant_linear2": 8,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.3.quant_linear1": 8,
        "transformer.encoder.layers.3.quant_linear2": 8,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.4.quant_linear1": 8,
        "transformer.encoder.layers.4.quant_linear2": 8,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.5.quant_linear1": 8,
        "transformer.encoder.layers.5.quant_linear2": 8,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 8,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 8,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 8,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 8,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 8,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 8,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 8,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 8,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 8,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 8,
        "class_embed.quant_in": 8,
        "class_embed.quant_linear": 8,
        "input_proj.quant_conv": 8,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 8,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 8,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 8,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 8,
        "stage1.unit1.quant_identity_convbn": 8,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 8,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 8,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 8,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 8,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 8,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 8,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 8,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 8,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 8,
        "stage2.unit1.quant_identity_convbn": 8,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 8,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 8,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 8,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 8,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 8,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 8,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 8,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 8,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 8,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 8,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 8,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 8,
        "stage3.unit1.quant_identity_convbn": 8,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 8,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 8,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 8,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 8,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 8,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 8,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 8,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 8,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 8,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 8,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 8,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 8,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 8,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 8,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 8,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 8,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 8,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 8,
        "stage4.unit1.quant_identity_convbn": 8,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 8,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 8,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 8,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 8,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 8,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 8,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 8
    },

    "bit_config_resnet101_detr4w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.0.quant_linear1": 4,
        "transformer.encoder.layers.0.quant_linear2": 4,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.1.quant_linear1": 4,
        "transformer.encoder.layers.1.quant_linear2": 4,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.2.quant_linear1": 4,
        "transformer.encoder.layers.2.quant_linear2": 4,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.3.quant_linear1": 4,
        "transformer.encoder.layers.3.quant_linear2": 4,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.4.quant_linear1": 4,
        "transformer.encoder.layers.4.quant_linear2": 4,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.5.quant_linear1": 4,
        "transformer.encoder.layers.5.quant_linear2": 4,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 4,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 4,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 4,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 4,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 4,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 4,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 4,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 4,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 4,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 4,
        "class_embed.quant_in": 4,
        "class_embed.quant_linear": 4,
        "input_proj.quant_conv": 4,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 4,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 4,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 4,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 4,
        "stage1.unit1.quant_identity_convbn": 4,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 4,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 4,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 4,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 4,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 4,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 4,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 4,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 4,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 4,
        "stage2.unit1.quant_identity_convbn": 4,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 4,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 4,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 4,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 4,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 4,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 4,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 4,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 4,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 4,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 4,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 4,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 4,
        "stage3.unit1.quant_identity_convbn": 4,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 4,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 4,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 4,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 4,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 4,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 4,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 4,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 4,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 4,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 4,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 4,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 4,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 4,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 4,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 4,
        "stage3.unit6.quant_act_int32": 0,
        "stage3.unit7.quant_act": 0,
        "stage3.unit7.quant_convbn1": 4,
        "stage3.unit7.quant_act1": 0,
        "stage3.unit7.quant_convbn2": 4,
        "stage3.unit7.quant_act2": 0,
        "stage3.unit7.quant_convbn3": 4,
        "stage3.unit7.quant_act_int32": 0,
        "stage3.unit8.quant_act": 0,
        "stage3.unit8.quant_convbn1": 4,
        "stage3.unit8.quant_act1": 0,
        "stage3.unit8.quant_convbn2": 4,
        "stage3.unit8.quant_act2": 0,
        "stage3.unit8.quant_convbn3": 4,
        "stage3.unit8.quant_act_int32": 0,
        "stage3.unit9.quant_act": 0,
        "stage3.unit9.quant_convbn1": 4,
        "stage3.unit9.quant_act1": 0,
        "stage3.unit9.quant_convbn2": 4,
        "stage3.unit9.quant_act2": 0,
        "stage3.unit9.quant_convbn3": 4,
        "stage3.unit9.quant_act_int32": 0,
        "stage3.unit10.quant_act": 0,
        "stage3.unit10.quant_convbn1": 4,
        "stage3.unit10.quant_act1": 0,
        "stage3.unit10.quant_convbn2": 4,
        "stage3.unit10.quant_act2": 0,
        "stage3.unit10.quant_convbn3": 4,
        "stage3.unit10.quant_act_int32": 0,
        "stage3.unit11.quant_act": 0,
        "stage3.unit11.quant_convbn1": 4,
        "stage3.unit11.quant_act1": 0,
        "stage3.unit11.quant_convbn2": 4,
        "stage3.unit11.quant_act2": 0,
        "stage3.unit11.quant_convbn3": 4,
        "stage3.unit11.quant_act_int32": 0,
        "stage3.unit12.quant_act": 0,
        "stage3.unit12.quant_convbn1": 4,
        "stage3.unit12.quant_act1": 0,
        "stage3.unit12.quant_convbn2": 4,
        "stage3.unit12.quant_act2": 0,
        "stage3.unit12.quant_convbn3": 4,
        "stage3.unit12.quant_act_int32": 0,
        "stage3.unit13.quant_act": 0,
        "stage3.unit13.quant_convbn1": 4,
        "stage3.unit13.quant_act1": 0,
        "stage3.unit13.quant_convbn2": 4,
        "stage3.unit13.quant_act2": 0,
        "stage3.unit13.quant_convbn3": 4,
        "stage3.unit13.quant_act_int32": 0,
        "stage3.unit14.quant_act": 0,
        "stage3.unit14.quant_convbn1": 4,
        "stage3.unit14.quant_act1": 0,
        "stage3.unit14.quant_convbn2": 4,
        "stage3.unit14.quant_act2": 0,
        "stage3.unit14.quant_convbn3": 4,
        "stage3.unit14.quant_act_int32": 0,
        "stage3.unit15.quant_act": 0,
        "stage3.unit15.quant_convbn1": 4,
        "stage3.unit15.quant_act1": 0,
        "stage3.unit15.quant_convbn2": 4,
        "stage3.unit15.quant_act2": 0,
        "stage3.unit15.quant_convbn3": 4,
        "stage3.unit15.quant_act_int32": 0,
        "stage3.unit16.quant_act": 0,
        "stage3.unit16.quant_convbn1": 4,
        "stage3.unit16.quant_act1": 0,
        "stage3.unit16.quant_convbn2": 4,
        "stage3.unit16.quant_act2": 0,
        "stage3.unit16.quant_convbn3": 4,
        "stage3.unit16.quant_act_int32": 0,
        "stage3.unit17.quant_act": 0,
        "stage3.unit17.quant_convbn1": 4,
        "stage3.unit17.quant_act1": 0,
        "stage3.unit17.quant_convbn2": 4,
        "stage3.unit17.quant_act2": 0,
        "stage3.unit17.quant_convbn3": 4,
        "stage3.unit17.quant_act_int32": 0,
        "stage3.unit18.quant_act": 0,
        "stage3.unit18.quant_convbn1": 4,
        "stage3.unit18.quant_act1": 0,
        "stage3.unit18.quant_convbn2": 4,
        "stage3.unit18.quant_act2": 0,
        "stage3.unit18.quant_convbn3": 4,
        "stage3.unit18.quant_act_int32": 0,
        "stage3.unit19.quant_act": 0,
        "stage3.unit19.quant_convbn1": 4,
        "stage3.unit19.quant_act1": 0,
        "stage3.unit19.quant_convbn2": 4,
        "stage3.unit19.quant_act2": 0,
        "stage3.unit19.quant_convbn3": 4,
        "stage3.unit19.quant_act_int32": 0,
        "stage3.unit20.quant_act": 0,
        "stage3.unit20.quant_convbn1": 4,
        "stage3.unit20.quant_act1": 0,
        "stage3.unit20.quant_convbn2": 4,
        "stage3.unit20.quant_act2": 0,
        "stage3.unit20.quant_convbn3": 4,
        "stage3.unit20.quant_act_int32": 0,
        "stage3.unit21.quant_act": 0,
        "stage3.unit21.quant_convbn1": 4,
        "stage3.unit21.quant_act1": 0,
        "stage3.unit21.quant_convbn2": 4,
        "stage3.unit21.quant_act2": 0,
        "stage3.unit21.quant_convbn3": 4,
        "stage3.unit21.quant_act_int32": 0,
        "stage3.unit22.quant_act": 0,
        "stage3.unit22.quant_convbn1": 4,
        "stage3.unit22.quant_act1": 0,
        "stage3.unit22.quant_convbn2": 4,
        "stage3.unit22.quant_act2": 0,
        "stage3.unit22.quant_convbn3": 4,
        "stage3.unit22.quant_act_int32": 0,
        "stage3.unit23.quant_act": 0,
        "stage3.unit23.quant_convbn1": 4,
        "stage3.unit23.quant_act1": 0,
        "stage3.unit23.quant_convbn2": 4,
        "stage3.unit23.quant_act2": 0,
        "stage3.unit23.quant_convbn3": 4,
        "stage3.unit23.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 4,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 4,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 4,
        "stage4.unit1.quant_identity_convbn": 4,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 4,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 4,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 4,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 4,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 4,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 4,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 8
    },


    "bit_config_resnet101_detr5w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.0.quant_linear1": 5,
        "transformer.encoder.layers.0.quant_linear2": 5,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.1.quant_linear1": 5,
        "transformer.encoder.layers.1.quant_linear2": 5,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.2.quant_linear1": 5,
        "transformer.encoder.layers.2.quant_linear2": 5,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.3.quant_linear1": 5,
        "transformer.encoder.layers.3.quant_linear2": 5,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.4.quant_linear1": 5,
        "transformer.encoder.layers.4.quant_linear2": 5,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.5.quant_linear1": 5,
        "transformer.encoder.layers.5.quant_linear2": 5,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 5,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 5,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 5,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 5,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 5,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 5,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 5,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 5,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 5,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 5,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 5,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 5,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 5,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 5,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 5,
        "class_embed.quant_in": 5,
        "class_embed.quant_linear": 5,
        "input_proj.quant_conv": 5,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 5,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 5,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 5,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 5,
        "stage1.unit1.quant_identity_convbn": 5,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 5,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 5,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 5,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 5,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 5,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 5,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 5,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 5,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 5,
        "stage2.unit1.quant_identity_convbn": 5,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 5,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 5,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 5,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 5,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 5,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 5,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 5,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 5,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 5,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 5,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 5,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 5,
        "stage3.unit1.quant_identity_convbn": 5,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 5,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 5,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 5,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 5,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 5,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 5,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 5,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 5,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 5,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 5,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 5,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 5,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 5,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 5,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 5,
        "stage3.unit6.quant_act_int32": 0,
        "stage3.unit7.quant_act": 0,
        "stage3.unit7.quant_convbn1": 5,
        "stage3.unit7.quant_act1": 0,
        "stage3.unit7.quant_convbn2": 5,
        "stage3.unit7.quant_act2": 0,
        "stage3.unit7.quant_convbn3": 5,
        "stage3.unit7.quant_act_int32": 0,
        "stage3.unit8.quant_act": 0,
        "stage3.unit8.quant_convbn1": 5,
        "stage3.unit8.quant_act1": 0,
        "stage3.unit8.quant_convbn2": 5,
        "stage3.unit8.quant_act2": 0,
        "stage3.unit8.quant_convbn3": 5,
        "stage3.unit8.quant_act_int32": 0,
        "stage3.unit9.quant_act": 0,
        "stage3.unit9.quant_convbn1": 5,
        "stage3.unit9.quant_act1": 0,
        "stage3.unit9.quant_convbn2": 5,
        "stage3.unit9.quant_act2": 0,
        "stage3.unit9.quant_convbn3": 5,
        "stage3.unit9.quant_act_int32": 0,
        "stage3.unit10.quant_act": 0,
        "stage3.unit10.quant_convbn1": 5,
        "stage3.unit10.quant_act1": 0,
        "stage3.unit10.quant_convbn2": 5,
        "stage3.unit10.quant_act2": 0,
        "stage3.unit10.quant_convbn3": 5,
        "stage3.unit10.quant_act_int32": 0,
        "stage3.unit11.quant_act": 0,
        "stage3.unit11.quant_convbn1": 5,
        "stage3.unit11.quant_act1": 0,
        "stage3.unit11.quant_convbn2": 5,
        "stage3.unit11.quant_act2": 0,
        "stage3.unit11.quant_convbn3": 5,
        "stage3.unit11.quant_act_int32": 0,
        "stage3.unit12.quant_act": 0,
        "stage3.unit12.quant_convbn1": 5,
        "stage3.unit12.quant_act1": 0,
        "stage3.unit12.quant_convbn2": 5,
        "stage3.unit12.quant_act2": 0,
        "stage3.unit12.quant_convbn3": 5,
        "stage3.unit12.quant_act_int32": 0,
        "stage3.unit13.quant_act": 0,
        "stage3.unit13.quant_convbn1": 5,
        "stage3.unit13.quant_act1": 0,
        "stage3.unit13.quant_convbn2": 5,
        "stage3.unit13.quant_act2": 0,
        "stage3.unit13.quant_convbn3": 5,
        "stage3.unit13.quant_act_int32": 0,
        "stage3.unit14.quant_act": 0,
        "stage3.unit14.quant_convbn1": 5,
        "stage3.unit14.quant_act1": 0,
        "stage3.unit14.quant_convbn2": 5,
        "stage3.unit14.quant_act2": 0,
        "stage3.unit14.quant_convbn3": 5,
        "stage3.unit14.quant_act_int32": 0,
        "stage3.unit15.quant_act": 0,
        "stage3.unit15.quant_convbn1": 5,
        "stage3.unit15.quant_act1": 0,
        "stage3.unit15.quant_convbn2": 5,
        "stage3.unit15.quant_act2": 0,
        "stage3.unit15.quant_convbn3": 5,
        "stage3.unit15.quant_act_int32": 0,
        "stage3.unit16.quant_act": 0,
        "stage3.unit16.quant_convbn1": 5,
        "stage3.unit16.quant_act1": 0,
        "stage3.unit16.quant_convbn2": 5,
        "stage3.unit16.quant_act2": 0,
        "stage3.unit16.quant_convbn3": 5,
        "stage3.unit16.quant_act_int32": 0,
        "stage3.unit17.quant_act": 0,
        "stage3.unit17.quant_convbn1": 5,
        "stage3.unit17.quant_act1": 0,
        "stage3.unit17.quant_convbn2": 5,
        "stage3.unit17.quant_act2": 0,
        "stage3.unit17.quant_convbn3": 5,
        "stage3.unit17.quant_act_int32": 0,
        "stage3.unit18.quant_act": 0,
        "stage3.unit18.quant_convbn1": 5,
        "stage3.unit18.quant_act1": 0,
        "stage3.unit18.quant_convbn2": 5,
        "stage3.unit18.quant_act2": 0,
        "stage3.unit18.quant_convbn3": 5,
        "stage3.unit18.quant_act_int32": 0,
        "stage3.unit19.quant_act": 0,
        "stage3.unit19.quant_convbn1": 5,
        "stage3.unit19.quant_act1": 0,
        "stage3.unit19.quant_convbn2": 5,
        "stage3.unit19.quant_act2": 0,
        "stage3.unit19.quant_convbn3": 5,
        "stage3.unit19.quant_act_int32": 0,
        "stage3.unit20.quant_act": 0,
        "stage3.unit20.quant_convbn1": 5,
        "stage3.unit20.quant_act1": 0,
        "stage3.unit20.quant_convbn2": 5,
        "stage3.unit20.quant_act2": 0,
        "stage3.unit20.quant_convbn3": 5,
        "stage3.unit20.quant_act_int32": 0,
        "stage3.unit21.quant_act": 0,
        "stage3.unit21.quant_convbn1": 5,
        "stage3.unit21.quant_act1": 0,
        "stage3.unit21.quant_convbn2": 5,
        "stage3.unit21.quant_act2": 0,
        "stage3.unit21.quant_convbn3": 5,
        "stage3.unit21.quant_act_int32": 0,
        "stage3.unit22.quant_act": 0,
        "stage3.unit22.quant_convbn1": 5,
        "stage3.unit22.quant_act1": 0,
        "stage3.unit22.quant_convbn2": 5,
        "stage3.unit22.quant_act2": 0,
        "stage3.unit22.quant_convbn3": 5,
        "stage3.unit22.quant_act_int32": 0,
        "stage3.unit23.quant_act": 0,
        "stage3.unit23.quant_convbn1": 5,
        "stage3.unit23.quant_act1": 0,
        "stage3.unit23.quant_convbn2": 5,
        "stage3.unit23.quant_act2": 0,
        "stage3.unit23.quant_convbn3": 5,
        "stage3.unit23.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 5,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 5,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 5,
        "stage4.unit1.quant_identity_convbn": 5,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 5,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 5,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 5,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 5,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 5,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 5,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 8
    },


    "bit_config_resnet101_detr6w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.0.quant_linear1": 6,
        "transformer.encoder.layers.0.quant_linear2": 6,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.1.quant_linear1": 6,
        "transformer.encoder.layers.1.quant_linear2": 6,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.2.quant_linear1": 6,
        "transformer.encoder.layers.2.quant_linear2": 6,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.3.quant_linear1": 6,
        "transformer.encoder.layers.3.quant_linear2": 6,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.4.quant_linear1": 6,
        "transformer.encoder.layers.4.quant_linear2": 6,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.5.quant_linear1": 6,
        "transformer.encoder.layers.5.quant_linear2": 6,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 6,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 6,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 6,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 6,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 6,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 6,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 6,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 6,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 6,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 6,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 6,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 6,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 6,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 6,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 6,
        "class_embed.quant_in": 6,
        "class_embed.quant_linear": 6,
        "input_proj.quant_conv": 6,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 6,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 6,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 6,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 6,
        "stage1.unit1.quant_identity_convbn": 6,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 6,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 6,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 6,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 6,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 6,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 6,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 6,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 6,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 6,
        "stage2.unit1.quant_identity_convbn": 6,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 6,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 6,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 6,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 6,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 6,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 6,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 6,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 6,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 6,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 6,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 6,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 6,
        "stage3.unit1.quant_identity_convbn": 6,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 6,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 6,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 6,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 6,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 6,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 6,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 6,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 6,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 6,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 6,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 6,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 6,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 6,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 6,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 6,
        "stage3.unit6.quant_act_int32": 0,
        "stage3.unit7.quant_act": 0,
        "stage3.unit7.quant_convbn1": 6,
        "stage3.unit7.quant_act1": 0,
        "stage3.unit7.quant_convbn2": 6,
        "stage3.unit7.quant_act2": 0,
        "stage3.unit7.quant_convbn3": 6,
        "stage3.unit7.quant_act_int32": 0,
        "stage3.unit8.quant_act": 0,
        "stage3.unit8.quant_convbn1": 6,
        "stage3.unit8.quant_act1": 0,
        "stage3.unit8.quant_convbn2": 6,
        "stage3.unit8.quant_act2": 0,
        "stage3.unit8.quant_convbn3": 6,
        "stage3.unit8.quant_act_int32": 0,
        "stage3.unit9.quant_act": 0,
        "stage3.unit9.quant_convbn1": 6,
        "stage3.unit9.quant_act1": 0,
        "stage3.unit9.quant_convbn2": 6,
        "stage3.unit9.quant_act2": 0,
        "stage3.unit9.quant_convbn3": 6,
        "stage3.unit9.quant_act_int32": 0,
        "stage3.unit10.quant_act": 0,
        "stage3.unit10.quant_convbn1": 6,
        "stage3.unit10.quant_act1": 0,
        "stage3.unit10.quant_convbn2": 6,
        "stage3.unit10.quant_act2": 0,
        "stage3.unit10.quant_convbn3": 6,
        "stage3.unit10.quant_act_int32": 0,
        "stage3.unit11.quant_act": 0,
        "stage3.unit11.quant_convbn1": 6,
        "stage3.unit11.quant_act1": 0,
        "stage3.unit11.quant_convbn2": 6,
        "stage3.unit11.quant_act2": 0,
        "stage3.unit11.quant_convbn3": 6,
        "stage3.unit11.quant_act_int32": 0,
        "stage3.unit12.quant_act": 0,
        "stage3.unit12.quant_convbn1": 6,
        "stage3.unit12.quant_act1": 0,
        "stage3.unit12.quant_convbn2": 6,
        "stage3.unit12.quant_act2": 0,
        "stage3.unit12.quant_convbn3": 6,
        "stage3.unit12.quant_act_int32": 0,
        "stage3.unit13.quant_act": 0,
        "stage3.unit13.quant_convbn1": 6,
        "stage3.unit13.quant_act1": 0,
        "stage3.unit13.quant_convbn2": 6,
        "stage3.unit13.quant_act2": 0,
        "stage3.unit13.quant_convbn3": 6,
        "stage3.unit13.quant_act_int32": 0,
        "stage3.unit14.quant_act": 0,
        "stage3.unit14.quant_convbn1": 6,
        "stage3.unit14.quant_act1": 0,
        "stage3.unit14.quant_convbn2": 6,
        "stage3.unit14.quant_act2": 0,
        "stage3.unit14.quant_convbn3": 6,
        "stage3.unit14.quant_act_int32": 0,
        "stage3.unit15.quant_act": 0,
        "stage3.unit15.quant_convbn1": 6,
        "stage3.unit15.quant_act1": 0,
        "stage3.unit15.quant_convbn2": 6,
        "stage3.unit15.quant_act2": 0,
        "stage3.unit15.quant_convbn3": 6,
        "stage3.unit15.quant_act_int32": 0,
        "stage3.unit16.quant_act": 0,
        "stage3.unit16.quant_convbn1": 6,
        "stage3.unit16.quant_act1": 0,
        "stage3.unit16.quant_convbn2": 6,
        "stage3.unit16.quant_act2": 0,
        "stage3.unit16.quant_convbn3": 6,
        "stage3.unit16.quant_act_int32": 0,
        "stage3.unit17.quant_act": 0,
        "stage3.unit17.quant_convbn1": 6,
        "stage3.unit17.quant_act1": 0,
        "stage3.unit17.quant_convbn2": 6,
        "stage3.unit17.quant_act2": 0,
        "stage3.unit17.quant_convbn3": 6,
        "stage3.unit17.quant_act_int32": 0,
        "stage3.unit18.quant_act": 0,
        "stage3.unit18.quant_convbn1": 6,
        "stage3.unit18.quant_act1": 0,
        "stage3.unit18.quant_convbn2": 6,
        "stage3.unit18.quant_act2": 0,
        "stage3.unit18.quant_convbn3": 6,
        "stage3.unit18.quant_act_int32": 0,
        "stage3.unit19.quant_act": 0,
        "stage3.unit19.quant_convbn1": 6,
        "stage3.unit19.quant_act1": 0,
        "stage3.unit19.quant_convbn2": 6,
        "stage3.unit19.quant_act2": 0,
        "stage3.unit19.quant_convbn3": 6,
        "stage3.unit19.quant_act_int32": 0,
        "stage3.unit20.quant_act": 0,
        "stage3.unit20.quant_convbn1": 6,
        "stage3.unit20.quant_act1": 0,
        "stage3.unit20.quant_convbn2": 6,
        "stage3.unit20.quant_act2": 0,
        "stage3.unit20.quant_convbn3": 6,
        "stage3.unit20.quant_act_int32": 0,
        "stage3.unit21.quant_act": 0,
        "stage3.unit21.quant_convbn1": 6,
        "stage3.unit21.quant_act1": 0,
        "stage3.unit21.quant_convbn2": 6,
        "stage3.unit21.quant_act2": 0,
        "stage3.unit21.quant_convbn3": 6,
        "stage3.unit21.quant_act_int32": 0,
        "stage3.unit22.quant_act": 0,
        "stage3.unit22.quant_convbn1": 6,
        "stage3.unit22.quant_act1": 0,
        "stage3.unit22.quant_convbn2": 6,
        "stage3.unit22.quant_act2": 0,
        "stage3.unit22.quant_convbn3": 6,
        "stage3.unit22.quant_act_int32": 0,
        "stage3.unit23.quant_act": 0,
        "stage3.unit23.quant_convbn1": 6,
        "stage3.unit23.quant_act1": 0,
        "stage3.unit23.quant_convbn2": 6,
        "stage3.unit23.quant_act2": 0,
        "stage3.unit23.quant_convbn3": 6,
        "stage3.unit23.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 6,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 6,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 6,
        "stage4.unit1.quant_identity_convbn": 6,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 6,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 6,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 6,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 6,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 6,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 6,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 8
    },


    "bit_config_resnet101_detr8w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.0.quant_linear1": 8,
        "transformer.encoder.layers.0.quant_linear2": 8,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.1.quant_linear1": 8,
        "transformer.encoder.layers.1.quant_linear2": 8,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.2.quant_linear1": 8,
        "transformer.encoder.layers.2.quant_linear2": 8,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.3.quant_linear1": 8,
        "transformer.encoder.layers.3.quant_linear2": 8,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.4.quant_linear1": 8,
        "transformer.encoder.layers.4.quant_linear2": 8,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.5.quant_linear1": 8,
        "transformer.encoder.layers.5.quant_linear2": 8,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 8,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 8,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 8,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 8,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 8,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 8,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 8,
        "bbox_embed.quant_act_in": 0,
        "bbox_embed.quant_linear1": 8,
        "bbox_embed.quant_act1": 0,
        "bbox_embed.quant_linear2": 8,
        "bbox_embed.quant_act2": 0,
        "bbox_embed.quant_linear3": 8,
        "class_embed.quant_in": 8,
        "class_embed.quant_linear": 8,
        "input_proj.quant_conv": 8,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 8,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 8,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 8,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 8,
        "stage1.unit1.quant_identity_convbn": 8,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 8,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 8,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 8,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 8,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 8,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 8,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 8,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 8,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 8,
        "stage2.unit1.quant_identity_convbn": 8,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 8,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 8,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 8,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 8,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 8,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 8,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 8,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 8,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 8,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 8,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 8,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 8,
        "stage3.unit1.quant_identity_convbn": 8,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 8,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 8,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 8,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 8,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 8,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 8,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 8,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 8,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 8,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 8,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 8,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 8,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 8,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 8,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 8,
        "stage3.unit6.quant_act_int32": 0,
        "stage3.unit7.quant_act": 0,
        "stage3.unit7.quant_convbn1": 8,
        "stage3.unit7.quant_act1": 0,
        "stage3.unit7.quant_convbn2": 8,
        "stage3.unit7.quant_act2": 0,
        "stage3.unit7.quant_convbn3": 8,
        "stage3.unit7.quant_act_int32": 0,
        "stage3.unit8.quant_act": 0,
        "stage3.unit8.quant_convbn1": 8,
        "stage3.unit8.quant_act1": 0,
        "stage3.unit8.quant_convbn2": 8,
        "stage3.unit8.quant_act2": 0,
        "stage3.unit8.quant_convbn3": 8,
        "stage3.unit8.quant_act_int32": 0,
        "stage3.unit9.quant_act": 0,
        "stage3.unit9.quant_convbn1": 8,
        "stage3.unit9.quant_act1": 0,
        "stage3.unit9.quant_convbn2": 8,
        "stage3.unit9.quant_act2": 0,
        "stage3.unit9.quant_convbn3": 8,
        "stage3.unit9.quant_act_int32": 0,
        "stage3.unit10.quant_act": 0,
        "stage3.unit10.quant_convbn1": 8,
        "stage3.unit10.quant_act1": 0,
        "stage3.unit10.quant_convbn2": 8,
        "stage3.unit10.quant_act2": 0,
        "stage3.unit10.quant_convbn3": 8,
        "stage3.unit10.quant_act_int32": 0,
        "stage3.unit11.quant_act": 0,
        "stage3.unit11.quant_convbn1": 8,
        "stage3.unit11.quant_act1": 0,
        "stage3.unit11.quant_convbn2": 8,
        "stage3.unit11.quant_act2": 0,
        "stage3.unit11.quant_convbn3": 8,
        "stage3.unit11.quant_act_int32": 0,
        "stage3.unit12.quant_act": 0,
        "stage3.unit12.quant_convbn1": 8,
        "stage3.unit12.quant_act1": 0,
        "stage3.unit12.quant_convbn2": 8,
        "stage3.unit12.quant_act2": 0,
        "stage3.unit12.quant_convbn3": 8,
        "stage3.unit12.quant_act_int32": 0,
        "stage3.unit13.quant_act": 0,
        "stage3.unit13.quant_convbn1": 8,
        "stage3.unit13.quant_act1": 0,
        "stage3.unit13.quant_convbn2": 8,
        "stage3.unit13.quant_act2": 0,
        "stage3.unit13.quant_convbn3": 8,
        "stage3.unit13.quant_act_int32": 0,
        "stage3.unit14.quant_act": 0,
        "stage3.unit14.quant_convbn1": 8,
        "stage3.unit14.quant_act1": 0,
        "stage3.unit14.quant_convbn2": 8,
        "stage3.unit14.quant_act2": 0,
        "stage3.unit14.quant_convbn3": 8,
        "stage3.unit14.quant_act_int32": 0,
        "stage3.unit15.quant_act": 0,
        "stage3.unit15.quant_convbn1": 8,
        "stage3.unit15.quant_act1": 0,
        "stage3.unit15.quant_convbn2": 8,
        "stage3.unit15.quant_act2": 0,
        "stage3.unit15.quant_convbn3": 8,
        "stage3.unit15.quant_act_int32": 0,
        "stage3.unit16.quant_act": 0,
        "stage3.unit16.quant_convbn1": 8,
        "stage3.unit16.quant_act1": 0,
        "stage3.unit16.quant_convbn2": 8,
        "stage3.unit16.quant_act2": 0,
        "stage3.unit16.quant_convbn3": 8,
        "stage3.unit16.quant_act_int32": 0,
        "stage3.unit17.quant_act": 0,
        "stage3.unit17.quant_convbn1": 8,
        "stage3.unit17.quant_act1": 0,
        "stage3.unit17.quant_convbn2": 8,
        "stage3.unit17.quant_act2": 0,
        "stage3.unit17.quant_convbn3": 8,
        "stage3.unit17.quant_act_int32": 0,
        "stage3.unit18.quant_act": 0,
        "stage3.unit18.quant_convbn1": 8,
        "stage3.unit18.quant_act1": 0,
        "stage3.unit18.quant_convbn2": 8,
        "stage3.unit18.quant_act2": 0,
        "stage3.unit18.quant_convbn3": 8,
        "stage3.unit18.quant_act_int32": 0,
        "stage3.unit19.quant_act": 0,
        "stage3.unit19.quant_convbn1": 8,
        "stage3.unit19.quant_act1": 0,
        "stage3.unit19.quant_convbn2": 8,
        "stage3.unit19.quant_act2": 0,
        "stage3.unit19.quant_convbn3": 8,
        "stage3.unit19.quant_act_int32": 0,
        "stage3.unit20.quant_act": 0,
        "stage3.unit20.quant_convbn1": 8,
        "stage3.unit20.quant_act1": 0,
        "stage3.unit20.quant_convbn2": 8,
        "stage3.unit20.quant_act2": 0,
        "stage3.unit20.quant_convbn3": 8,
        "stage3.unit20.quant_act_int32": 0,
        "stage3.unit21.quant_act": 0,
        "stage3.unit21.quant_convbn1": 8,
        "stage3.unit21.quant_act1": 0,
        "stage3.unit21.quant_convbn2": 8,
        "stage3.unit21.quant_act2": 0,
        "stage3.unit21.quant_convbn3": 8,
        "stage3.unit21.quant_act_int32": 0,
        "stage3.unit22.quant_act": 0,
        "stage3.unit22.quant_convbn1": 8,
        "stage3.unit22.quant_act1": 0,
        "stage3.unit22.quant_convbn2": 8,
        "stage3.unit22.quant_act2": 0,
        "stage3.unit22.quant_convbn3": 8,
        "stage3.unit22.quant_act_int32": 0,
        "stage3.unit23.quant_act": 0,
        "stage3.unit23.quant_convbn1": 8,
        "stage3.unit23.quant_act1": 0,
        "stage3.unit23.quant_convbn2": 8,
        "stage3.unit23.quant_act2": 0,
        "stage3.unit23.quant_convbn3": 8,
        "stage3.unit23.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 8,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 8,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 8,
        "stage4.unit1.quant_identity_convbn": 8,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 8,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 8,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 8,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 8,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 8,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 8,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 8
    },


    "bit_config_resnet101_detr8w8a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.0.quant_linear1": 8,
        "transformer.encoder.layers.0.quant_linear2": 8,
        "transformer.encoder.layers.0.quant_act1": 8,
        "transformer.encoder.layers.0.quant_act2": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.1.quant_linear1": 8,
        "transformer.encoder.layers.1.quant_linear2": 8,
        "transformer.encoder.layers.1.quant_act1": 8,
        "transformer.encoder.layers.1.quant_act2": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.2.quant_linear1": 8,
        "transformer.encoder.layers.2.quant_linear2": 8,
        "transformer.encoder.layers.2.quant_act1": 8,
        "transformer.encoder.layers.2.quant_act2": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.3.quant_linear1": 8,
        "transformer.encoder.layers.3.quant_linear2": 8,
        "transformer.encoder.layers.3.quant_act1": 8,
        "transformer.encoder.layers.3.quant_act2": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.4.quant_linear1": 8,
        "transformer.encoder.layers.4.quant_linear2": 8,
        "transformer.encoder.layers.4.quant_act1": 8,
        "transformer.encoder.layers.4.quant_act2": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 8,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 8,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 8,
        "transformer.encoder.layers.5.quant_linear1": 8,
        "transformer.encoder.layers.5.quant_linear2": 8,
        "transformer.encoder.layers.5.quant_act1": 8,
        "transformer.encoder.layers.5.quant_act2": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.0.quant_act1": 8,
        "transformer.decoder.layers.0.quant_linear1": 8,
        "transformer.decoder.layers.0.quant_act2": 8,
        "transformer.decoder.layers.0.quant_linear2": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.1.quant_act1": 8,
        "transformer.decoder.layers.1.quant_linear1": 8,
        "transformer.decoder.layers.1.quant_act2": 8,
        "transformer.decoder.layers.1.quant_linear2": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.2.quant_act1": 8,
        "transformer.decoder.layers.2.quant_linear1": 8,
        "transformer.decoder.layers.2.quant_act2": 8,
        "transformer.decoder.layers.2.quant_linear2": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.3.quant_act1": 8,
        "transformer.decoder.layers.3.quant_linear1": 8,
        "transformer.decoder.layers.3.quant_act2": 8,
        "transformer.decoder.layers.3.quant_linear2": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.4.quant_act1": 8,
        "transformer.decoder.layers.4.quant_linear1": 8,
        "transformer.decoder.layers.4.quant_act2": 8,
        "transformer.decoder.layers.4.quant_linear2": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 8,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 8,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 8,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 8,
        "transformer.decoder.layers.5.quant_act1": 8,
        "transformer.decoder.layers.5.quant_linear1": 8,
        "transformer.decoder.layers.5.quant_act2": 8,
        "transformer.decoder.layers.5.quant_linear2": 8,
        'bbox_embed.quant_act_in': 8,
        'bbox_embed.quant_linear1': 8,
        'bbox_embed.quant_act1': 8,
        'bbox_embed.quant_linear2': 8,
        'bbox_embed.quant_act2': 8,
        'bbox_embed.quant_linear3': 8,

        'class_embed.quant_in': 8,
        'class_embed.quant_linear': 8,

        'input_proj.quant_conv': 8,
        'input_proj.quant_act_in': 8,

        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 8,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 8,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 8,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage3.unit7.quant_act': 8,
        'stage3.unit7.quant_convbn1': 8,
        'stage3.unit7.quant_act1': 8,
        'stage3.unit7.quant_convbn2': 8,
        'stage3.unit7.quant_act2': 8,
        'stage3.unit7.quant_convbn3': 8,
        'stage3.unit7.quant_act_int32': 16,

        'stage3.unit8.quant_act': 8,
        'stage3.unit8.quant_convbn1': 8,
        'stage3.unit8.quant_act1': 8,
        'stage3.unit8.quant_convbn2': 8,
        'stage3.unit8.quant_act2': 8,
        'stage3.unit8.quant_convbn3': 8,
        'stage3.unit8.quant_act_int32': 16,

        'stage3.unit9.quant_act': 8,
        'stage3.unit9.quant_convbn1': 8,
        'stage3.unit9.quant_act1': 8,
        'stage3.unit9.quant_convbn2': 8,
        'stage3.unit9.quant_act2': 8,
        'stage3.unit9.quant_convbn3': 8,
        'stage3.unit9.quant_act_int32': 16,

        'stage3.unit10.quant_act': 8,
        'stage3.unit10.quant_convbn1': 8,
        'stage3.unit10.quant_act1': 8,
        'stage3.unit10.quant_convbn2': 8,
        'stage3.unit10.quant_act2': 8,
        'stage3.unit10.quant_convbn3': 8,
        'stage3.unit10.quant_act_int32': 16,

        'stage3.unit11.quant_act': 8,
        'stage3.unit11.quant_convbn1': 8,
        'stage3.unit11.quant_act1': 8,
        'stage3.unit11.quant_convbn2': 8,
        'stage3.unit11.quant_act2': 8,
        'stage3.unit11.quant_convbn3': 8,
        'stage3.unit11.quant_act_int32': 16,

        'stage3.unit12.quant_act': 8,
        'stage3.unit12.quant_convbn1': 8,
        'stage3.unit12.quant_act1': 8,
        'stage3.unit12.quant_convbn2': 8,
        'stage3.unit12.quant_act2': 8,
        'stage3.unit12.quant_convbn3': 8,
        'stage3.unit12.quant_act_int32': 16,

        'stage3.unit13.quant_act': 8,
        'stage3.unit13.quant_convbn1': 8,
        'stage3.unit13.quant_act1': 8,
        'stage3.unit13.quant_convbn2': 8,
        'stage3.unit13.quant_act2': 8,
        'stage3.unit13.quant_convbn3': 8,
        'stage3.unit13.quant_act_int32': 16,

        'stage3.unit14.quant_act': 8,
        'stage3.unit14.quant_convbn1': 8,
        'stage3.unit14.quant_act1': 8,
        'stage3.unit14.quant_convbn2': 8,
        'stage3.unit14.quant_act2': 8,
        'stage3.unit14.quant_convbn3': 8,
        'stage3.unit14.quant_act_int32': 16,

        'stage3.unit15.quant_act': 8,
        'stage3.unit15.quant_convbn1': 8,
        'stage3.unit15.quant_act1': 8,
        'stage3.unit15.quant_convbn2': 8,
        'stage3.unit15.quant_act2': 8,
        'stage3.unit15.quant_convbn3': 8,
        'stage3.unit15.quant_act_int32': 16,

        'stage3.unit16.quant_act': 8,
        'stage3.unit16.quant_convbn1': 8,
        'stage3.unit16.quant_act1': 8,
        'stage3.unit16.quant_convbn2': 8,
        'stage3.unit16.quant_act2': 8,
        'stage3.unit16.quant_convbn3': 8,
        'stage3.unit16.quant_act_int32': 16,

        'stage3.unit17.quant_act': 8,
        'stage3.unit17.quant_convbn1': 8,
        'stage3.unit17.quant_act1': 8,
        'stage3.unit17.quant_convbn2': 8,
        'stage3.unit17.quant_act2': 8,
        'stage3.unit17.quant_convbn3': 8,
        'stage3.unit17.quant_act_int32': 16,

        'stage3.unit18.quant_act': 8,
        'stage3.unit18.quant_convbn1': 8,
        'stage3.unit18.quant_act1': 8,
        'stage3.unit18.quant_convbn2': 8,
        'stage3.unit18.quant_act2': 8,
        'stage3.unit18.quant_convbn3': 8,
        'stage3.unit18.quant_act_int32': 16,

        'stage3.unit19.quant_act': 8,
        'stage3.unit19.quant_convbn1': 8,
        'stage3.unit19.quant_act1': 8,
        'stage3.unit19.quant_convbn2': 8,
        'stage3.unit19.quant_act2': 8,
        'stage3.unit19.quant_convbn3': 8,
        'stage3.unit19.quant_act_int32': 16,

        'stage3.unit20.quant_act': 8,
        'stage3.unit20.quant_convbn1': 8,
        'stage3.unit20.quant_act1': 8,
        'stage3.unit20.quant_convbn2': 8,
        'stage3.unit20.quant_act2': 8,
        'stage3.unit20.quant_convbn3': 8,
        'stage3.unit20.quant_act_int32': 16,

        'stage3.unit21.quant_act': 8,
        'stage3.unit21.quant_convbn1': 8,
        'stage3.unit21.quant_act1': 8,
        'stage3.unit21.quant_convbn2': 8,
        'stage3.unit21.quant_act2': 8,
        'stage3.unit21.quant_convbn3': 8,
        'stage3.unit21.quant_act_int32': 16,

        'stage3.unit22.quant_act': 8,
        'stage3.unit22.quant_convbn1': 8,
        'stage3.unit22.quant_act1': 8,
        'stage3.unit22.quant_convbn2': 8,
        'stage3.unit22.quant_act2': 8,
        'stage3.unit22.quant_convbn3': 8,
        'stage3.unit22.quant_act_int32': 16,

        'stage3.unit23.quant_act': 8,
        'stage3.unit23.quant_convbn1': 8,
        'stage3.unit23.quant_act1': 8,
        'stage3.unit23.quant_convbn2': 8,
        'stage3.unit23.quant_act2': 8,
        'stage3.unit23.quant_convbn3': 8,
        'stage3.unit23.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },



    "bit_config_resnet50_detr16w16a": {
        # 'query_embed.quant_emb':8,
        'bbox_embed.quant_act_in': 16,
        'bbox_embed.quant_linear1': 16,
        'bbox_embed.quant_act1': 16,
        'bbox_embed.quant_linear2': 16,
        'bbox_embed.quant_act2': 16,
        'bbox_embed.quant_linear3': 16,

        'class_embed.quant_in': 16,
        'class_embed.quant_linear': 16,

        'input_proj.quant_conv': 16,
        'input_proj.quant_act_in': 16,

        'quant_input': 16,
        'quant_init_convbn': 16,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 16,
        'stage1.unit1.quant_convbn1': 16,
        'stage1.unit1.quant_act1': 16,
        'stage1.unit1.quant_convbn2': 16,
        'stage1.unit1.quant_act2': 16,
        'stage1.unit1.quant_convbn3': 16,
        'stage1.unit1.quant_identity_convbn': 16,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 16,
        'stage1.unit2.quant_convbn1': 16,
        'stage1.unit2.quant_act1': 16,
        'stage1.unit2.quant_convbn2': 16,
        'stage1.unit2.quant_act2': 16,
        'stage1.unit2.quant_convbn3': 16,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 16,
        'stage1.unit3.quant_convbn1': 16,
        'stage1.unit3.quant_act1': 16,
        'stage1.unit3.quant_convbn2': 16,
        'stage1.unit3.quant_act2': 16,
        'stage1.unit3.quant_convbn3': 16,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 16,
        'stage2.unit1.quant_convbn1': 16,
        'stage2.unit1.quant_act1': 16,
        'stage2.unit1.quant_convbn2': 16,
        'stage2.unit1.quant_act2': 16,
        'stage2.unit1.quant_convbn3': 16,
        'stage2.unit1.quant_identity_convbn': 16,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 16,
        'stage2.unit2.quant_convbn1': 16,
        'stage2.unit2.quant_act1': 16,
        'stage2.unit2.quant_convbn2': 16,
        'stage2.unit2.quant_act2': 16,
        'stage2.unit2.quant_convbn3': 16,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 16,
        'stage2.unit3.quant_convbn1': 16,
        'stage2.unit3.quant_act1': 16,
        'stage2.unit3.quant_convbn2': 16,
        'stage2.unit3.quant_act2': 16,
        'stage2.unit3.quant_convbn3': 16,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 16,
        'stage2.unit4.quant_convbn1': 16,
        'stage2.unit4.quant_act1': 16,
        'stage2.unit4.quant_convbn2': 16,
        'stage2.unit4.quant_act2': 16,
        'stage2.unit4.quant_convbn3': 16,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 16,
        'stage3.unit1.quant_convbn1': 16,
        'stage3.unit1.quant_act1': 16,
        'stage3.unit1.quant_convbn2': 16,
        'stage3.unit1.quant_act2': 16,
        'stage3.unit1.quant_convbn3': 16,
        'stage3.unit1.quant_identity_convbn': 16,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 16,
        'stage3.unit2.quant_convbn1': 16,
        'stage3.unit2.quant_act1': 16,
        'stage3.unit2.quant_convbn2': 16,
        'stage3.unit2.quant_act2': 16,
        'stage3.unit2.quant_convbn3': 16,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 16,
        'stage3.unit3.quant_convbn1': 16,
        'stage3.unit3.quant_act1': 16,
        'stage3.unit3.quant_convbn2': 16,
        'stage3.unit3.quant_act2': 16,
        'stage3.unit3.quant_convbn3': 16,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 16,
        'stage3.unit4.quant_convbn1': 16,
        'stage3.unit4.quant_act1': 16,
        'stage3.unit4.quant_convbn2': 16,
        'stage3.unit4.quant_act2': 16,
        'stage3.unit4.quant_convbn3': 16,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 16,
        'stage3.unit5.quant_convbn1': 16,
        'stage3.unit5.quant_act1': 16,
        'stage3.unit5.quant_convbn2': 16,
        'stage3.unit5.quant_act2': 16,
        'stage3.unit5.quant_convbn3': 16,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 16,
        'stage3.unit6.quant_convbn1': 16,
        'stage3.unit6.quant_act1': 16,
        'stage3.unit6.quant_convbn2': 16,
        'stage3.unit6.quant_act2': 16,
        'stage3.unit6.quant_convbn3': 16,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 16,
        'stage4.unit1.quant_convbn1': 16,
        'stage4.unit1.quant_act1': 16,
        'stage4.unit1.quant_convbn2': 16,
        'stage4.unit1.quant_act2': 16,
        'stage4.unit1.quant_convbn3': 16,
        'stage4.unit1.quant_identity_convbn': 16,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 16,
        'stage4.unit2.quant_convbn1': 16,
        'stage4.unit2.quant_act1': 16,
        'stage4.unit2.quant_convbn2': 16,
        'stage4.unit2.quant_act2': 16,
        'stage4.unit2.quant_convbn3': 16,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 16,
        'stage4.unit3.quant_convbn1': 16,
        'stage4.unit3.quant_act1': 16,
        'stage4.unit3.quant_convbn2': 16,
        'stage4.unit3.quant_act2': 16,
        'stage4.unit3.quant_convbn3': 16,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 16,
        'quant_output': 16
    },




    "bit_config_resnet50_detr8w32a": {
        # 'query_embed.quant_emb':8,
        'bbox_embed.quant_act_in': 32,
        'bbox_embed.quant_linear1': 8,
        'bbox_embed.quant_act1': 32,
        'bbox_embed.quant_linear2': 8,
        'bbox_embed.quant_act2': 32,
        'bbox_embed.quant_linear3': 8,

        'class_embed.quant_in': 32,
        'class_embed.quant_linear': 8,

        'input_proj.quant_conv': 8,
        'input_proj.quant_act_in': 32,

        'quant_input': 32,
        'quant_init_convbn': 8,
        'quant_act_int32': 32,

        'stage1.unit1.quant_act': 32,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 32,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 32,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 32,

        'stage1.unit2.quant_act': 32,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 32,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 32,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 32,

        'stage1.unit3.quant_act': 32,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 32,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 32,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 32,

        'stage2.unit1.quant_act': 32,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 32,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 32,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 32,

        'stage2.unit2.quant_act': 32,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 32,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 32,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 32,

        'stage2.unit3.quant_act': 32,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 32,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 32,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 32,

        'stage2.unit4.quant_act': 32,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 32,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 32,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 32,

        'stage3.unit1.quant_act': 32,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 32,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 32,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 32,

        'stage3.unit2.quant_act': 32,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 32,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 32,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 32,

        'stage3.unit3.quant_act': 32,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 32,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 32,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 32,

        'stage3.unit4.quant_act': 32,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 32,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 32,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 32,

        'stage3.unit5.quant_act': 32,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 32,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 32,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 32,

        'stage3.unit6.quant_act': 32,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 32,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 32,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 32,

        'stage4.unit1.quant_act': 32,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 32,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 32,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 32,

        'stage4.unit2.quant_act': 32,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 32,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 32,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 32,

        'stage4.unit3.quant_act': 32,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 32,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 32,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 32,

        'quant_act_output': 32,
        'quant_output': 32
    },



    "bit_config_resnet50_detr8w16a": {
        # 'query_embed.quant_emb':8,
        'bbox_embed.quant_act_in': 16,
        'bbox_embed.quant_linear1': 8,
        'bbox_embed.quant_act1': 16,
        'bbox_embed.quant_linear2': 8,
        'bbox_embed.quant_act2': 16,
        'bbox_embed.quant_linear3': 8,

        'class_embed.quant_in': 16,
        'class_embed.quant_linear': 8,

        'input_proj.quant_conv': 8,
        'input_proj.quant_act_in': 16,

        'quant_input': 16,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 16,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 16,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 16,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 16,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 16,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 16,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 16,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 16,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 16,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 16,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 16,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 16,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 16,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 16,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 16,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 16,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 16,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 16,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 16,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 16,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 16,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 16,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 16,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 16,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 16,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 16,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 16,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 16,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 16,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 16,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 16,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 16,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 16,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 16,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 16,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 16,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 16,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 16,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 16,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 16,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 16,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 16,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 16,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 16,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 16,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 16,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 16,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 16,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 16,
        'quant_output': 16
    },




    "bit_config_resnet50_detr8w8a": {
        # 'query_embed.quant_emb':8,
        'bbox_embed.quant_act_in': 8,
        'bbox_embed.quant_linear1': 8,
        'bbox_embed.quant_act1': 8,
        'bbox_embed.quant_linear2': 8,
        'bbox_embed.quant_act2': 8,
        'bbox_embed.quant_linear3': 8,

        'class_embed.quant_in': 8,
        'class_embed.quant_linear': 8,

        'input_proj.quant_conv': 8,
        'input_proj.quant_act_in': 8,

        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 8,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 8,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 8,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_detr4w4a": {
        # 'query_embed.quant_emb':8,
        'bbox_embed.quant_act_in': 8,
        'bbox_embed.quant_linear1': 4,
        'bbox_embed.quant_act1': 4,
        'bbox_embed.quant_linear2': 4,
        'bbox_embed.quant_act2': 4,
        'bbox_embed.quant_linear3': 4,

        'class_embed.quant_in': 4,
        'class_embed.quant_linear': 4,

        'input_proj.quant_conv': 4,
        'input_proj.quant_act_int': 4,

        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 4,
        'stage1.unit1.quant_convbn1': 4,
        'stage1.unit1.quant_act1': 4,
        'stage1.unit1.quant_convbn2': 4,
        'stage1.unit1.quant_act2': 4,
        'stage1.unit1.quant_convbn3': 4,
        'stage1.unit1.quant_identity_convbn': 4,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 4,
        'stage1.unit2.quant_convbn1': 4,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act2': 4,
        'stage1.unit2.quant_convbn3': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 4,
        'stage1.unit3.quant_convbn1': 4,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 4,
        'stage2.unit1.quant_convbn1': 4,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 4,
        'stage2.unit1.quant_convbn3': 4,
        'stage2.unit1.quant_identity_convbn': 4,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 4,
        'stage2.unit4.quant_convbn1': 4,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 4,
        'stage3.unit1.quant_convbn3': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 4,
        'stage4.unit1.quant_convbn3': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 4,
        'stage4.unit3.quant_convbn1': 4,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },



    "bit_config_resnet50_detr4w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.0.quant_linear1": 4,
        "transformer.encoder.layers.0.quant_linear2": 4,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.1.quant_linear1": 4,
        "transformer.encoder.layers.1.quant_linear2": 4,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.2.quant_linear1": 4,
        "transformer.encoder.layers.2.quant_linear2": 4,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.3.quant_linear1": 4,
        "transformer.encoder.layers.3.quant_linear2": 4,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.4.quant_linear1": 4,
        "transformer.encoder.layers.4.quant_linear2": 4,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 4,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 4,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 4,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 4,
        "transformer.encoder.layers.5.quant_linear1": 4,
        "transformer.encoder.layers.5.quant_linear2": 4,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 4,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 4,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 4,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 4,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 4,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 4,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 4,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 4,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 4,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 4,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 4,
        "input_proj.quant_conv": 4,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 4,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 4,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 4,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 4,
        "stage1.unit1.quant_identity_convbn": 4,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 4,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 4,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 4,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 4,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 4,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 4,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 4,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 4,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 4,
        "stage2.unit1.quant_identity_convbn": 4,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 4,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 4,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 4,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 4,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 4,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 4,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 4,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 4,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 4,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 4,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 4,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 4,
        "stage3.unit1.quant_identity_convbn": 4,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 4,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 4,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 4,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 4,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 4,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 4,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 4,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 4,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 4,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 4,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 4,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 4,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 4,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 4,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 4,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 4,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 4,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 4,
        "stage4.unit1.quant_identity_convbn": 4,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 4,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 4,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 4,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 4,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 4,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 4,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 4
    },


    "bit_config_resnet50_detr5w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.0.quant_linear1": 5,
        "transformer.encoder.layers.0.quant_linear2": 5,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.1.quant_linear1": 5,
        "transformer.encoder.layers.1.quant_linear2": 5,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.2.quant_linear1": 5,
        "transformer.encoder.layers.2.quant_linear2": 5,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.3.quant_linear1": 5,
        "transformer.encoder.layers.3.quant_linear2": 5,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.4.quant_linear1": 5,
        "transformer.encoder.layers.4.quant_linear2": 5,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 5,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 5,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 5,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 5,
        "transformer.encoder.layers.5.quant_linear1": 5,
        "transformer.encoder.layers.5.quant_linear2": 5,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 5,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 5,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 5,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 5,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 5,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 5,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 5,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 5,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 5,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 5,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 5,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 5,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 5,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 5,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 5,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 5,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 5,
        "input_proj.quant_conv": 5,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 5,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 5,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 5,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 5,
        "stage1.unit1.quant_identity_convbn": 5,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 5,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 5,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 5,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 5,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 5,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 5,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 5,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 5,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 5,
        "stage2.unit1.quant_identity_convbn": 5,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 5,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 5,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 5,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 5,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 5,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 5,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 5,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 5,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 5,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 5,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 5,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 5,
        "stage3.unit1.quant_identity_convbn": 5,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 5,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 5,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 5,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 5,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 5,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 5,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 5,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 5,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 5,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 5,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 5,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 5,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 5,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 5,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 5,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 5,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 5,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 5,
        "stage4.unit1.quant_identity_convbn": 5,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 5,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 5,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 5,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 5,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 5,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 5,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 5
    },


    "bit_config_resnet50_detr6w0a": {
        "transformer.encoder.layers.0.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.0.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.0.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.0.quant_linear1": 6,
        "transformer.encoder.layers.0.quant_linear2": 6,
        "transformer.encoder.layers.0.quant_act1": 0,
        "transformer.encoder.layers.0.quant_act2": 0,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.1.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.1.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.1.quant_linear1": 6,
        "transformer.encoder.layers.1.quant_linear2": 6,
        "transformer.encoder.layers.1.quant_act1": 0,
        "transformer.encoder.layers.1.quant_act2": 0,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.2.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.2.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.2.quant_linear1": 6,
        "transformer.encoder.layers.2.quant_linear2": 6,
        "transformer.encoder.layers.2.quant_act1": 0,
        "transformer.encoder.layers.2.quant_act2": 0,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.3.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.3.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.3.quant_linear1": 6,
        "transformer.encoder.layers.3.quant_linear2": 6,
        "transformer.encoder.layers.3.quant_act1": 0,
        "transformer.encoder.layers.3.quant_act2": 0,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.4.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.4.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.4.quant_linear1": 6,
        "transformer.encoder.layers.4.quant_linear2": 6,
        "transformer.encoder.layers.4.quant_act1": 0,
        "transformer.encoder.layers.4.quant_act2": 0,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_q": 6,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_k": 6,
        "transformer.encoder.layers.5.quant_self_attn.in_proj_v": 6,
        "transformer.encoder.layers.5.quant_self_attn.out_proj": 6,
        "transformer.encoder.layers.5.quant_linear1": 6,
        "transformer.encoder.layers.5.quant_linear2": 6,
        "transformer.encoder.layers.5.quant_act1": 0,
        "transformer.encoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.0.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.0.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.0.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.0.quant_act1": 0,
        "transformer.decoder.layers.0.quant_linear1": 6,
        "transformer.decoder.layers.0.quant_act2": 0,
        "transformer.decoder.layers.0.quant_linear2": 6,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.1.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.1.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.1.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.1.quant_act1": 0,
        "transformer.decoder.layers.1.quant_linear1": 6,
        "transformer.decoder.layers.1.quant_act2": 0,
        "transformer.decoder.layers.1.quant_linear2": 6,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.2.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.2.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.2.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.2.quant_act1": 0,
        "transformer.decoder.layers.2.quant_linear1": 6,
        "transformer.decoder.layers.2.quant_act2": 0,
        "transformer.decoder.layers.2.quant_linear2": 6,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.3.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.3.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.3.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.3.quant_act1": 0,
        "transformer.decoder.layers.3.quant_linear1": 6,
        "transformer.decoder.layers.3.quant_act2": 0,
        "transformer.decoder.layers.3.quant_linear2": 6,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.4.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.4.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.4.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.4.quant_act1": 0,
        "transformer.decoder.layers.4.quant_linear1": 6,
        "transformer.decoder.layers.4.quant_act2": 0,
        "transformer.decoder.layers.4.quant_linear2": 6,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_q": 6,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_k": 6,
        "transformer.decoder.layers.5.quant_self_attn.in_proj_v": 6,
        "transformer.decoder.layers.5.quant_self_attn.out_proj": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_q": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_k": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.in_proj_v": 6,
        "transformer.decoder.layers.5.quant_multihead_attn.out_proj": 6,
        "transformer.decoder.layers.5.quant_act1": 0,
        "transformer.decoder.layers.5.quant_linear1": 6,
        "transformer.decoder.layers.5.quant_act2": 0,
        "transformer.decoder.layers.5.quant_linear2": 6,
        "input_proj.quant_conv": 6,
        "input_proj.quant_act_in": 0,
        "quant_input": 0,
        "quant_init_convbn": 6,
        "quant_act_int32": 0,
        "stage1.unit1.quant_act": 0,
        "stage1.unit1.quant_convbn1": 6,
        "stage1.unit1.quant_act1": 0,
        "stage1.unit1.quant_convbn2": 6,
        "stage1.unit1.quant_act2": 0,
        "stage1.unit1.quant_convbn3": 6,
        "stage1.unit1.quant_identity_convbn": 6,
        "stage1.unit1.quant_act_int32": 0,
        "stage1.unit2.quant_act": 0,
        "stage1.unit2.quant_convbn1": 6,
        "stage1.unit2.quant_act1": 0,
        "stage1.unit2.quant_convbn2": 6,
        "stage1.unit2.quant_act2": 0,
        "stage1.unit2.quant_convbn3": 6,
        "stage1.unit2.quant_act_int32": 0,
        "stage1.unit3.quant_act": 0,
        "stage1.unit3.quant_convbn1": 6,
        "stage1.unit3.quant_act1": 0,
        "stage1.unit3.quant_convbn2": 6,
        "stage1.unit3.quant_act2": 0,
        "stage1.unit3.quant_convbn3": 6,
        "stage1.unit3.quant_act_int32": 0,
        "stage2.unit1.quant_act": 0,
        "stage2.unit1.quant_convbn1": 6,
        "stage2.unit1.quant_act1": 0,
        "stage2.unit1.quant_convbn2": 6,
        "stage2.unit1.quant_act2": 0,
        "stage2.unit1.quant_convbn3": 6,
        "stage2.unit1.quant_identity_convbn": 6,
        "stage2.unit1.quant_act_int32": 0,
        "stage2.unit2.quant_act": 0,
        "stage2.unit2.quant_convbn1": 6,
        "stage2.unit2.quant_act1": 0,
        "stage2.unit2.quant_convbn2": 6,
        "stage2.unit2.quant_act2": 0,
        "stage2.unit2.quant_convbn3": 6,
        "stage2.unit2.quant_act_int32": 0,
        "stage2.unit3.quant_act": 0,
        "stage2.unit3.quant_convbn1": 6,
        "stage2.unit3.quant_act1": 0,
        "stage2.unit3.quant_convbn2": 6,
        "stage2.unit3.quant_act2": 0,
        "stage2.unit3.quant_convbn3": 6,
        "stage2.unit3.quant_act_int32": 0,
        "stage2.unit4.quant_act": 0,
        "stage2.unit4.quant_convbn1": 6,
        "stage2.unit4.quant_act1": 0,
        "stage2.unit4.quant_convbn2": 6,
        "stage2.unit4.quant_act2": 0,
        "stage2.unit4.quant_convbn3": 6,
        "stage2.unit4.quant_act_int32": 0,
        "stage3.unit1.quant_act": 0,
        "stage3.unit1.quant_convbn1": 6,
        "stage3.unit1.quant_act1": 0,
        "stage3.unit1.quant_convbn2": 6,
        "stage3.unit1.quant_act2": 0,
        "stage3.unit1.quant_convbn3": 6,
        "stage3.unit1.quant_identity_convbn": 6,
        "stage3.unit1.quant_act_int32": 0,
        "stage3.unit2.quant_act": 0,
        "stage3.unit2.quant_convbn1": 6,
        "stage3.unit2.quant_act1": 0,
        "stage3.unit2.quant_convbn2": 6,
        "stage3.unit2.quant_act2": 0,
        "stage3.unit2.quant_convbn3": 6,
        "stage3.unit2.quant_act_int32": 0,
        "stage3.unit3.quant_act": 0,
        "stage3.unit3.quant_convbn1": 6,
        "stage3.unit3.quant_act1": 0,
        "stage3.unit3.quant_convbn2": 6,
        "stage3.unit3.quant_act2": 0,
        "stage3.unit3.quant_convbn3": 6,
        "stage3.unit3.quant_act_int32": 0,
        "stage3.unit4.quant_act": 0,
        "stage3.unit4.quant_convbn1": 6,
        "stage3.unit4.quant_act1": 0,
        "stage3.unit4.quant_convbn2": 6,
        "stage3.unit4.quant_act2": 0,
        "stage3.unit4.quant_convbn3": 6,
        "stage3.unit4.quant_act_int32": 0,
        "stage3.unit5.quant_act": 0,
        "stage3.unit5.quant_convbn1": 6,
        "stage3.unit5.quant_act1": 0,
        "stage3.unit5.quant_convbn2": 6,
        "stage3.unit5.quant_act2": 0,
        "stage3.unit5.quant_convbn3": 6,
        "stage3.unit5.quant_act_int32": 0,
        "stage3.unit6.quant_act": 0,
        "stage3.unit6.quant_convbn1": 6,
        "stage3.unit6.quant_act1": 0,
        "stage3.unit6.quant_convbn2": 6,
        "stage3.unit6.quant_act2": 0,
        "stage3.unit6.quant_convbn3": 6,
        "stage3.unit6.quant_act_int32": 0,
        "stage4.unit1.quant_act": 0,
        "stage4.unit1.quant_convbn1": 6,
        "stage4.unit1.quant_act1": 0,
        "stage4.unit1.quant_convbn2": 6,
        "stage4.unit1.quant_act2": 0,
        "stage4.unit1.quant_convbn3": 6,
        "stage4.unit1.quant_identity_convbn": 6,
        "stage4.unit1.quant_act_int32": 0,
        "stage4.unit2.quant_act": 0,
        "stage4.unit2.quant_convbn1": 6,
        "stage4.unit2.quant_act1": 0,
        "stage4.unit2.quant_convbn2": 6,
        "stage4.unit2.quant_act2": 0,
        "stage4.unit2.quant_convbn3": 6,
        "stage4.unit2.quant_act_int32": 0,
        "stage4.unit3.quant_act": 0,
        "stage4.unit3.quant_convbn1": 6,
        "stage4.unit3.quant_act1": 0,
        "stage4.unit3.quant_convbn2": 6,
        "stage4.unit3.quant_act2": 0,
        "stage4.unit3.quant_convbn3": 6,
        "stage4.unit3.quant_act_int32": 0,
        "quant_act_output": 0,
        "quant_output": 6
    },




    'bit_config_resnet50_uniform_w6a6': {'quant_input': 8,
                                         'quant_init_convbn': 6,
                                         'quant_act_int32': 16,
                                         'stage1.unit1.quant_act': 6,
                                         'stage1.unit1.quant_convbn1': 6,
                                         'stage1.unit1.quant_act1': 6,
                                         'stage1.unit1.quant_convbn2': 6,
                                         'stage1.unit1.quant_act2': 6,
                                         'stage1.unit1.quant_convbn3': 6,
                                         'stage1.unit1.quant_identity_convbn': 6,
                                         'stage1.unit1.quant_act_int32': 16,
                                         'stage1.unit2.quant_act': 6,
                                         'stage1.unit2.quant_convbn1': 6,
                                         'stage1.unit2.quant_act1': 6,
                                         'stage1.unit2.quant_convbn2': 6,
                                         'stage1.unit2.quant_act2': 6,
                                         'stage1.unit2.quant_convbn3': 6,
                                         'stage1.unit2.quant_act_int32': 16,
                                         'stage1.unit3.quant_act': 6,
                                         'stage1.unit3.quant_convbn1': 6,
                                         'stage1.unit3.quant_act1': 6,
                                         'stage1.unit3.quant_convbn2': 6,
                                         'stage1.unit3.quant_act2': 6,
                                         'stage1.unit3.quant_convbn3': 6,
                                         'stage1.unit3.quant_act_int32': 16,
                                         'stage2.unit1.quant_act': 6,
                                         'stage2.unit1.quant_convbn1': 6,
                                         'stage2.unit1.quant_act1': 6,
                                         'stage2.unit1.quant_convbn2': 6,
                                         'stage2.unit1.quant_act2': 6,
                                         'stage2.unit1.quant_convbn3': 6,
                                         'stage2.unit1.quant_identity_convbn': 6,
                                         'stage2.unit1.quant_act_int32': 16,
                                         'stage2.unit2.quant_act': 6,
                                         'stage2.unit2.quant_convbn1': 6,
                                         'stage2.unit2.quant_act1': 6,
                                         'stage2.unit2.quant_convbn2': 6,
                                         'stage2.unit2.quant_act2': 6,
                                         'stage2.unit2.quant_convbn3': 6,
                                         'stage2.unit2.quant_act_int32': 16,
                                         'stage2.unit3.quant_act': 6,
                                         'stage2.unit3.quant_convbn1': 6,
                                         'stage2.unit3.quant_act1': 6,
                                         'stage2.unit3.quant_convbn2': 6,
                                         'stage2.unit3.quant_act2': 6,
                                         'stage2.unit3.quant_convbn3': 6,
                                         'stage2.unit3.quant_act_int32': 16,
                                         'stage2.unit4.quant_act': 6,
                                         'stage2.unit4.quant_convbn1': 6,
                                         'stage2.unit4.quant_act1': 6,
                                         'stage2.unit4.quant_convbn2': 6,
                                         'stage2.unit4.quant_act2': 6,
                                         'stage2.unit4.quant_convbn3': 6,
                                         'stage2.unit4.quant_act_int32': 16,
                                         'stage3.unit1.quant_act': 6,
                                         'stage3.unit1.quant_convbn1': 6,
                                         'stage3.unit1.quant_act1': 6,
                                         'stage3.unit1.quant_convbn2': 6,
                                         'stage3.unit1.quant_act2': 6,
                                         'stage3.unit1.quant_convbn3': 6,
                                         'stage3.unit1.quant_identity_convbn': 6,
                                         'stage3.unit1.quant_act_int32': 16,
                                         'stage3.unit2.quant_act': 6,
                                         'stage3.unit2.quant_convbn1': 6,
                                         'stage3.unit2.quant_act1': 6,
                                         'stage3.unit2.quant_convbn2': 6,
                                         'stage3.unit2.quant_act2': 6,
                                         'stage3.unit2.quant_convbn3': 6,
                                         'stage3.unit2.quant_act_int32': 16,
                                         'stage3.unit3.quant_act': 6,
                                         'stage3.unit3.quant_convbn1': 6,
                                         'stage3.unit3.quant_act1': 6,
                                         'stage3.unit3.quant_convbn2': 6,
                                         'stage3.unit3.quant_act2': 6,
                                         'stage3.unit3.quant_convbn3': 6,
                                         'stage3.unit3.quant_act_int32': 16,
                                         'stage3.unit4.quant_act': 6,
                                         'stage3.unit4.quant_convbn1': 6,
                                         'stage3.unit4.quant_act1': 6,
                                         'stage3.unit4.quant_convbn2': 6,
                                         'stage3.unit4.quant_act2': 6,
                                         'stage3.unit4.quant_convbn3': 6,
                                         'stage3.unit4.quant_act_int32': 16,
                                         'stage3.unit5.quant_act': 6,
                                         'stage3.unit5.quant_convbn1': 6,
                                         'stage3.unit5.quant_act1': 6,
                                         'stage3.unit5.quant_convbn2': 6,
                                         'stage3.unit5.quant_act2': 6,
                                         'stage3.unit5.quant_convbn3': 6,
                                         'stage3.unit5.quant_act_int32': 16,
                                         'stage3.unit6.quant_act': 6,
                                         'stage3.unit6.quant_convbn1': 6,
                                         'stage3.unit6.quant_act1': 6,
                                         'stage3.unit6.quant_convbn2': 6,
                                         'stage3.unit6.quant_act2': 6,
                                         'stage3.unit6.quant_convbn3': 6,
                                         'stage3.unit6.quant_act_int32': 16,
                                         'stage4.unit1.quant_act': 6,
                                         'stage4.unit1.quant_convbn1': 6,
                                         'stage4.unit1.quant_act1': 6,
                                         'stage4.unit1.quant_convbn2': 6,
                                         'stage4.unit1.quant_act2': 6,
                                         'stage4.unit1.quant_convbn3': 6,
                                         'stage4.unit1.quant_identity_convbn': 6,
                                         'stage4.unit1.quant_act_int32': 16,
                                         'stage4.unit2.quant_act': 6,
                                         'stage4.unit2.quant_convbn1': 6,
                                         'stage4.unit2.quant_act1': 6,
                                         'stage4.unit2.quant_convbn2': 6,
                                         'stage4.unit2.quant_act2': 6,
                                         'stage4.unit2.quant_convbn3': 6,
                                         'stage4.unit2.quant_act_int32': 16,
                                         'stage4.unit3.quant_act': 6,
                                         'stage4.unit3.quant_convbn1': 6,
                                         'stage4.unit3.quant_act1': 6,
                                         'stage4.unit3.quant_convbn2': 6,
                                         'stage4.unit3.quant_act2': 6,
                                         'stage4.unit3.quant_convbn3': 6,
                                         'stage4.unit3.quant_act_int32': 16,
                                         'quant_act_output': 6,
                                         'quant_output': 8},

    'bit_config_resnet50_uniform_w4a8': {'quant_input': 8,
                                         'quant_init_convbn': 4,
                                         'quant_act_int32': 16,
                                         'stage1.unit1.quant_act': 8,
                                         'stage1.unit1.quant_convbn1': 4,
                                         'stage1.unit1.quant_act1': 8,
                                         'stage1.unit1.quant_convbn2': 4,
                                         'stage1.unit1.quant_act2': 8,
                                         'stage1.unit1.quant_convbn3': 4,
                                         'stage1.unit1.quant_identity_convbn': 4,
                                         'stage1.unit1.quant_act_int32': 16,
                                         'stage1.unit2.quant_act': 8,
                                         'stage1.unit2.quant_convbn1': 4,
                                         'stage1.unit2.quant_act1': 8,
                                         'stage1.unit2.quant_convbn2': 4,
                                         'stage1.unit2.quant_act2': 8,
                                         'stage1.unit2.quant_convbn3': 4,
                                         'stage1.unit2.quant_act_int32': 16,
                                         'stage1.unit3.quant_act': 8,
                                         'stage1.unit3.quant_convbn1': 4,
                                         'stage1.unit3.quant_act1': 8,
                                         'stage1.unit3.quant_convbn2': 4,
                                         'stage1.unit3.quant_act2': 8,
                                         'stage1.unit3.quant_convbn3': 4,
                                         'stage1.unit3.quant_act_int32': 16,
                                         'stage2.unit1.quant_act': 8,
                                         'stage2.unit1.quant_convbn1': 4,
                                         'stage2.unit1.quant_act1': 8,
                                         'stage2.unit1.quant_convbn2': 4,
                                         'stage2.unit1.quant_act2': 8,
                                         'stage2.unit1.quant_convbn3': 4,
                                         'stage2.unit1.quant_identity_convbn': 4,
                                         'stage2.unit1.quant_act_int32': 16,
                                         'stage2.unit2.quant_act': 8,
                                         'stage2.unit2.quant_convbn1': 4,
                                         'stage2.unit2.quant_act1': 8,
                                         'stage2.unit2.quant_convbn2': 4,
                                         'stage2.unit2.quant_act2': 8,
                                         'stage2.unit2.quant_convbn3': 4,
                                         'stage2.unit2.quant_act_int32': 16,
                                         'stage2.unit3.quant_act': 8,
                                         'stage2.unit3.quant_convbn1': 4,
                                         'stage2.unit3.quant_act1': 8,
                                         'stage2.unit3.quant_convbn2': 4,
                                         'stage2.unit3.quant_act2': 8,
                                         'stage2.unit3.quant_convbn3': 4,
                                         'stage2.unit3.quant_act_int32': 16,
                                         'stage2.unit4.quant_act': 8,
                                         'stage2.unit4.quant_convbn1': 4,
                                         'stage2.unit4.quant_act1': 8,
                                         'stage2.unit4.quant_convbn2': 4,
                                         'stage2.unit4.quant_act2': 8,
                                         'stage2.unit4.quant_convbn3': 4,
                                         'stage2.unit4.quant_act_int32': 16,
                                         'stage3.unit1.quant_act': 8,
                                         'stage3.unit1.quant_convbn1': 4,
                                         'stage3.unit1.quant_act1': 8,
                                         'stage3.unit1.quant_convbn2': 4,
                                         'stage3.unit1.quant_act2': 8,
                                         'stage3.unit1.quant_convbn3': 4,
                                         'stage3.unit1.quant_identity_convbn': 4,
                                         'stage3.unit1.quant_act_int32': 16,
                                         'stage3.unit2.quant_act': 8,
                                         'stage3.unit2.quant_convbn1': 4,
                                         'stage3.unit2.quant_act1': 8,
                                         'stage3.unit2.quant_convbn2': 4,
                                         'stage3.unit2.quant_act2': 8,
                                         'stage3.unit2.quant_convbn3': 4,
                                         'stage3.unit2.quant_act_int32': 16,
                                         'stage3.unit3.quant_act': 8,
                                         'stage3.unit3.quant_convbn1': 4,
                                         'stage3.unit3.quant_act1': 8,
                                         'stage3.unit3.quant_convbn2': 4,
                                         'stage3.unit3.quant_act2': 8,
                                         'stage3.unit3.quant_convbn3': 4,
                                         'stage3.unit3.quant_act_int32': 16,
                                         'stage3.unit4.quant_act': 8,
                                         'stage3.unit4.quant_convbn1': 4,
                                         'stage3.unit4.quant_act1': 8,
                                         'stage3.unit4.quant_convbn2': 4,
                                         'stage3.unit4.quant_act2': 8,
                                         'stage3.unit4.quant_convbn3': 4,
                                         'stage3.unit4.quant_act_int32': 16,
                                         'stage3.unit5.quant_act': 8,
                                         'stage3.unit5.quant_convbn1': 4,
                                         'stage3.unit5.quant_act1': 8,
                                         'stage3.unit5.quant_convbn2': 4,
                                         'stage3.unit5.quant_act2': 8,
                                         'stage3.unit5.quant_convbn3': 4,
                                         'stage3.unit5.quant_act_int32': 16,
                                         'stage3.unit6.quant_act': 8,
                                         'stage3.unit6.quant_convbn1': 4,
                                         'stage3.unit6.quant_act1': 8,
                                         'stage3.unit6.quant_convbn2': 4,
                                         'stage3.unit6.quant_act2': 8,
                                         'stage3.unit6.quant_convbn3': 4,
                                         'stage3.unit6.quant_act_int32': 16,
                                         'stage4.unit1.quant_act': 8,
                                         'stage4.unit1.quant_convbn1': 4,
                                         'stage4.unit1.quant_act1': 8,
                                         'stage4.unit1.quant_convbn2': 4,
                                         'stage4.unit1.quant_act2': 8,
                                         'stage4.unit1.quant_convbn3': 4,
                                         'stage4.unit1.quant_identity_convbn': 4,
                                         'stage4.unit1.quant_act_int32': 16,
                                         'stage4.unit2.quant_act': 8,
                                         'stage4.unit2.quant_convbn1': 4,
                                         'stage4.unit2.quant_act1': 8,
                                         'stage4.unit2.quant_convbn2': 4,
                                         'stage4.unit2.quant_act2': 8,
                                         'stage4.unit2.quant_convbn3': 4,
                                         'stage4.unit2.quant_act_int32': 16,
                                         'stage4.unit3.quant_act': 8,
                                         'stage4.unit3.quant_convbn1': 4,
                                         'stage4.unit3.quant_act1': 8,
                                         'stage4.unit3.quant_convbn2': 4,
                                         'stage4.unit3.quant_act2': 8,
                                         'stage4.unit3.quant_convbn3': 4,
                                         'stage4.unit3.quant_act_int32': 16,
                                         'quant_act_output': 8,
                                         'quant_output': 8},

    "bit_config_resnet18_uniform8": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_uniform4": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 4,
        'stage1.unit1.quant_convbn1': 4,
        'stage1.unit1.quant_act1': 4,
        'stage1.unit1.quant_convbn2': 4,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 4,
        'stage1.unit2.quant_convbn1': 4,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 4,
        'stage2.unit1.quant_convbn1': 4,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_identity_convbn': 4,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },


    "bit_config_resnet18_modelsize_0.75": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_modelsize_0.5": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_modelsize_0.25": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_bops_0.75": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_bops_0.5": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_bops_0.25": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_latency_0.75": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_latency_0.5": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet18_latency_0.25": {
        'quant_input': 8,
        'quant_init_block_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },


    "bit_config_resnet50_uniform8": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 8,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 8,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 8,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_uniform4": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 4,
        'stage1.unit1.quant_convbn1': 4,
        'stage1.unit1.quant_act1': 4,
        'stage1.unit1.quant_convbn2': 4,
        'stage1.unit1.quant_act2': 4,
        'stage1.unit1.quant_convbn3': 4,
        'stage1.unit1.quant_identity_convbn': 4,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 4,
        'stage1.unit2.quant_convbn1': 4,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act2': 4,
        'stage1.unit2.quant_convbn3': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 4,
        'stage1.unit3.quant_convbn1': 4,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 4,
        'stage2.unit1.quant_convbn1': 4,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 4,
        'stage2.unit1.quant_convbn3': 4,
        'stage2.unit1.quant_identity_convbn': 4,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 4,
        'stage2.unit4.quant_convbn1': 4,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 4,
        'stage3.unit1.quant_convbn3': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 4,
        'stage4.unit1.quant_convbn3': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 4,
        'stage4.unit3.quant_convbn1': 4,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },


    "bit_config_resnet50_modelsize_0.75": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 8,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 8,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 8,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_modelsize_0.5": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_modelsize_0.25": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_bops_0.75": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_bops_0.5": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_bops_0.25": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 4,
        'stage1.unit1.quant_convbn2': 4,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 4,
        'stage1.unit2.quant_convbn1': 4,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_latency_0.75": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_latency_0.5": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50_latency_0.25": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50b_uniform8": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 8,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 8,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 8,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet50b_uniform4": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 4,
        'stage1.unit1.quant_convbn1': 4,
        'stage1.unit1.quant_act1': 4,
        'stage1.unit1.quant_convbn2': 4,
        'stage1.unit1.quant_act2': 4,
        'stage1.unit1.quant_convbn3': 4,
        'stage1.unit1.quant_identity_convbn': 4,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 4,
        'stage1.unit2.quant_convbn1': 4,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act2': 4,
        'stage1.unit2.quant_convbn3': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 4,
        'stage1.unit3.quant_convbn1': 4,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 4,
        'stage2.unit1.quant_convbn1': 4,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 4,
        'stage2.unit1.quant_convbn3': 4,
        'stage2.unit1.quant_identity_convbn': 4,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 4,
        'stage2.unit4.quant_convbn1': 4,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 4,
        'stage3.unit1.quant_convbn3': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 4,
        'stage4.unit1.quant_convbn3': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 4,
        'stage4.unit3.quant_convbn1': 4,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet101_uniform8": {

        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 8,
        'stage1.unit1.quant_convbn1': 8,
        'stage1.unit1.quant_act1': 8,
        'stage1.unit1.quant_convbn2': 8,
        'stage1.unit1.quant_act2': 8,
        'stage1.unit1.quant_convbn3': 8,
        'stage1.unit1.quant_identity_convbn': 8,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 8,
        'stage1.unit2.quant_convbn1': 8,
        'stage1.unit2.quant_act1': 8,
        'stage1.unit2.quant_convbn2': 8,
        'stage1.unit2.quant_act2': 8,
        'stage1.unit2.quant_convbn3': 8,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 8,
        'stage1.unit3.quant_convbn1': 8,
        'stage1.unit3.quant_act1': 8,
        'stage1.unit3.quant_convbn2': 8,
        'stage1.unit3.quant_act2': 8,
        'stage1.unit3.quant_convbn3': 8,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 8,
        'stage2.unit1.quant_convbn1': 8,
        'stage2.unit1.quant_act1': 8,
        'stage2.unit1.quant_convbn2': 8,
        'stage2.unit1.quant_act2': 8,
        'stage2.unit1.quant_convbn3': 8,
        'stage2.unit1.quant_identity_convbn': 8,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 8,
        'stage2.unit2.quant_convbn1': 8,
        'stage2.unit2.quant_act1': 8,
        'stage2.unit2.quant_convbn2': 8,
        'stage2.unit2.quant_act2': 8,
        'stage2.unit2.quant_convbn3': 8,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 8,
        'stage2.unit3.quant_convbn1': 8,
        'stage2.unit3.quant_act1': 8,
        'stage2.unit3.quant_convbn2': 8,
        'stage2.unit3.quant_act2': 8,
        'stage2.unit3.quant_convbn3': 8,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 8,
        'stage2.unit4.quant_convbn1': 8,
        'stage2.unit4.quant_act1': 8,
        'stage2.unit4.quant_convbn2': 8,
        'stage2.unit4.quant_act2': 8,
        'stage2.unit4.quant_convbn3': 8,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 8,
        'stage3.unit1.quant_convbn1': 8,
        'stage3.unit1.quant_act1': 8,
        'stage3.unit1.quant_convbn2': 8,
        'stage3.unit1.quant_act2': 8,
        'stage3.unit1.quant_convbn3': 8,
        'stage3.unit1.quant_identity_convbn': 8,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 8,
        'stage3.unit2.quant_convbn1': 8,
        'stage3.unit2.quant_act1': 8,
        'stage3.unit2.quant_convbn2': 8,
        'stage3.unit2.quant_act2': 8,
        'stage3.unit2.quant_convbn3': 8,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 8,
        'stage3.unit3.quant_convbn1': 8,
        'stage3.unit3.quant_act1': 8,
        'stage3.unit3.quant_convbn2': 8,
        'stage3.unit3.quant_act2': 8,
        'stage3.unit3.quant_convbn3': 8,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 8,
        'stage3.unit4.quant_convbn1': 8,
        'stage3.unit4.quant_act1': 8,
        'stage3.unit4.quant_convbn2': 8,
        'stage3.unit4.quant_act2': 8,
        'stage3.unit4.quant_convbn3': 8,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 8,
        'stage3.unit5.quant_convbn1': 8,
        'stage3.unit5.quant_act1': 8,
        'stage3.unit5.quant_convbn2': 8,
        'stage3.unit5.quant_act2': 8,
        'stage3.unit5.quant_convbn3': 8,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 8,
        'stage3.unit6.quant_convbn1': 8,
        'stage3.unit6.quant_act1': 8,
        'stage3.unit6.quant_convbn2': 8,
        'stage3.unit6.quant_act2': 8,
        'stage3.unit6.quant_convbn3': 8,
        'stage3.unit6.quant_act_int32': 16,

        'stage3.unit7.quant_act': 8,
        'stage3.unit7.quant_convbn1': 8,
        'stage3.unit7.quant_act1': 8,
        'stage3.unit7.quant_convbn2': 8,
        'stage3.unit7.quant_act2': 8,
        'stage3.unit7.quant_convbn3': 8,
        'stage3.unit7.quant_act_int32': 16,

        'stage3.unit8.quant_act': 8,
        'stage3.unit8.quant_convbn1': 8,
        'stage3.unit8.quant_act1': 8,
        'stage3.unit8.quant_convbn2': 8,
        'stage3.unit8.quant_act2': 8,
        'stage3.unit8.quant_convbn3': 8,
        'stage3.unit8.quant_act_int32': 16,

        'stage3.unit9.quant_act': 8,
        'stage3.unit9.quant_convbn1': 8,
        'stage3.unit9.quant_act1': 8,
        'stage3.unit9.quant_convbn2': 8,
        'stage3.unit9.quant_act2': 8,
        'stage3.unit9.quant_convbn3': 8,
        'stage3.unit9.quant_act_int32': 16,

        'stage3.unit10.quant_act': 8,
        'stage3.unit10.quant_convbn1': 8,
        'stage3.unit10.quant_act1': 8,
        'stage3.unit10.quant_convbn2': 8,
        'stage3.unit10.quant_act2': 8,
        'stage3.unit10.quant_convbn3': 8,
        'stage3.unit10.quant_act_int32': 16,

        'stage3.unit11.quant_act': 8,
        'stage3.unit11.quant_convbn1': 8,
        'stage3.unit11.quant_act1': 8,
        'stage3.unit11.quant_convbn2': 8,
        'stage3.unit11.quant_act2': 8,
        'stage3.unit11.quant_convbn3': 8,
        'stage3.unit11.quant_act_int32': 16,

        'stage3.unit12.quant_act': 8,
        'stage3.unit12.quant_convbn1': 8,
        'stage3.unit12.quant_act1': 8,
        'stage3.unit12.quant_convbn2': 8,
        'stage3.unit12.quant_act2': 8,
        'stage3.unit12.quant_convbn3': 8,
        'stage3.unit12.quant_act_int32': 16,

        'stage3.unit13.quant_act': 8,
        'stage3.unit13.quant_convbn1': 8,
        'stage3.unit13.quant_act1': 8,
        'stage3.unit13.quant_convbn2': 8,
        'stage3.unit13.quant_act2': 8,
        'stage3.unit13.quant_convbn3': 8,
        'stage3.unit13.quant_act_int32': 16,

        'stage3.unit14.quant_act': 8,
        'stage3.unit14.quant_convbn1': 8,
        'stage3.unit14.quant_act1': 8,
        'stage3.unit14.quant_convbn2': 8,
        'stage3.unit14.quant_act2': 8,
        'stage3.unit14.quant_convbn3': 8,
        'stage3.unit14.quant_act_int32': 16,

        'stage3.unit15.quant_act': 8,
        'stage3.unit15.quant_convbn1': 8,
        'stage3.unit15.quant_act1': 8,
        'stage3.unit15.quant_convbn2': 8,
        'stage3.unit15.quant_act2': 8,
        'stage3.unit15.quant_convbn3': 8,
        'stage3.unit15.quant_act_int32': 16,

        'stage3.unit16.quant_act': 8,
        'stage3.unit16.quant_convbn1': 8,
        'stage3.unit16.quant_act1': 8,
        'stage3.unit16.quant_convbn2': 8,
        'stage3.unit16.quant_act2': 8,
        'stage3.unit16.quant_convbn3': 8,
        'stage3.unit16.quant_act_int32': 16,

        'stage3.unit17.quant_act': 8,
        'stage3.unit17.quant_convbn1': 8,
        'stage3.unit17.quant_act1': 8,
        'stage3.unit17.quant_convbn2': 8,
        'stage3.unit17.quant_act2': 8,
        'stage3.unit17.quant_convbn3': 8,
        'stage3.unit17.quant_act_int32': 16,

        'stage3.unit18.quant_act': 8,
        'stage3.unit18.quant_convbn1': 8,
        'stage3.unit18.quant_act1': 8,
        'stage3.unit18.quant_convbn2': 8,
        'stage3.unit18.quant_act2': 8,
        'stage3.unit18.quant_convbn3': 8,
        'stage3.unit18.quant_act_int32': 16,

        'stage3.unit19.quant_act': 8,
        'stage3.unit19.quant_convbn1': 8,
        'stage3.unit19.quant_act1': 8,
        'stage3.unit19.quant_convbn2': 8,
        'stage3.unit19.quant_act2': 8,
        'stage3.unit19.quant_convbn3': 8,
        'stage3.unit19.quant_act_int32': 16,

        'stage3.unit20.quant_act': 8,
        'stage3.unit20.quant_convbn1': 8,
        'stage3.unit20.quant_act1': 8,
        'stage3.unit20.quant_convbn2': 8,
        'stage3.unit20.quant_act2': 8,
        'stage3.unit20.quant_convbn3': 8,
        'stage3.unit20.quant_act_int32': 16,

        'stage3.unit21.quant_act': 8,
        'stage3.unit21.quant_convbn1': 8,
        'stage3.unit21.quant_act1': 8,
        'stage3.unit21.quant_convbn2': 8,
        'stage3.unit21.quant_act2': 8,
        'stage3.unit21.quant_convbn3': 8,
        'stage3.unit21.quant_act_int32': 16,

        'stage3.unit22.quant_act': 8,
        'stage3.unit22.quant_convbn1': 8,
        'stage3.unit22.quant_act1': 8,
        'stage3.unit22.quant_convbn2': 8,
        'stage3.unit22.quant_act2': 8,
        'stage3.unit22.quant_convbn3': 8,
        'stage3.unit22.quant_act_int32': 16,

        'stage3.unit23.quant_act': 8,
        'stage3.unit23.quant_convbn1': 8,
        'stage3.unit23.quant_act1': 8,
        'stage3.unit23.quant_convbn2': 8,
        'stage3.unit23.quant_act2': 8,
        'stage3.unit23.quant_convbn3': 8,
        'stage3.unit23.quant_act_int32': 16,

        'stage4.unit1.quant_act': 8,
        'stage4.unit1.quant_convbn1': 8,
        'stage4.unit1.quant_act1': 8,
        'stage4.unit1.quant_convbn2': 8,
        'stage4.unit1.quant_act2': 8,
        'stage4.unit1.quant_convbn3': 8,
        'stage4.unit1.quant_identity_convbn': 8,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 8,
        'stage4.unit2.quant_convbn1': 8,
        'stage4.unit2.quant_act1': 8,
        'stage4.unit2.quant_convbn2': 8,
        'stage4.unit2.quant_act2': 8,
        'stage4.unit2.quant_convbn3': 8,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 8,
        'stage4.unit3.quant_convbn1': 8,
        'stage4.unit3.quant_act1': 8,
        'stage4.unit3.quant_convbn2': 8,
        'stage4.unit3.quant_act2': 8,
        'stage4.unit3.quant_convbn3': 8,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },

    "bit_config_resnet101_uniform4": {
        'quant_input': 8,
        'quant_init_convbn': 8,
        'quant_act_int32': 16,

        'stage1.unit1.quant_act': 4,
        'stage1.unit1.quant_convbn1': 4,
        'stage1.unit1.quant_act1': 4,
        'stage1.unit1.quant_convbn2': 4,
        'stage1.unit1.quant_act2': 4,
        'stage1.unit1.quant_convbn3': 4,
        'stage1.unit1.quant_identity_convbn': 4,
        'stage1.unit1.quant_act_int32': 16,

        'stage1.unit2.quant_act': 4,
        'stage1.unit2.quant_convbn1': 4,
        'stage1.unit2.quant_act1': 4,
        'stage1.unit2.quant_convbn2': 4,
        'stage1.unit2.quant_act2': 4,
        'stage1.unit2.quant_convbn3': 4,
        'stage1.unit2.quant_act_int32': 16,

        'stage1.unit3.quant_act': 4,
        'stage1.unit3.quant_convbn1': 4,
        'stage1.unit3.quant_act1': 4,
        'stage1.unit3.quant_convbn2': 4,
        'stage1.unit3.quant_act2': 4,
        'stage1.unit3.quant_convbn3': 4,
        'stage1.unit3.quant_act_int32': 16,

        'stage2.unit1.quant_act': 4,
        'stage2.unit1.quant_convbn1': 4,
        'stage2.unit1.quant_act1': 4,
        'stage2.unit1.quant_convbn2': 4,
        'stage2.unit1.quant_act2': 4,
        'stage2.unit1.quant_convbn3': 4,
        'stage2.unit1.quant_identity_convbn': 4,
        'stage2.unit1.quant_act_int32': 16,

        'stage2.unit2.quant_act': 4,
        'stage2.unit2.quant_convbn1': 4,
        'stage2.unit2.quant_act1': 4,
        'stage2.unit2.quant_convbn2': 4,
        'stage2.unit2.quant_act2': 4,
        'stage2.unit2.quant_convbn3': 4,
        'stage2.unit2.quant_act_int32': 16,

        'stage2.unit3.quant_act': 4,
        'stage2.unit3.quant_convbn1': 4,
        'stage2.unit3.quant_act1': 4,
        'stage2.unit3.quant_convbn2': 4,
        'stage2.unit3.quant_act2': 4,
        'stage2.unit3.quant_convbn3': 4,
        'stage2.unit3.quant_act_int32': 16,

        'stage2.unit4.quant_act': 4,
        'stage2.unit4.quant_convbn1': 4,
        'stage2.unit4.quant_act1': 4,
        'stage2.unit4.quant_convbn2': 4,
        'stage2.unit4.quant_act2': 4,
        'stage2.unit4.quant_convbn3': 4,
        'stage2.unit4.quant_act_int32': 16,

        'stage3.unit1.quant_act': 4,
        'stage3.unit1.quant_convbn1': 4,
        'stage3.unit1.quant_act1': 4,
        'stage3.unit1.quant_convbn2': 4,
        'stage3.unit1.quant_act2': 4,
        'stage3.unit1.quant_convbn3': 4,
        'stage3.unit1.quant_identity_convbn': 4,
        'stage3.unit1.quant_act_int32': 16,

        'stage3.unit2.quant_act': 4,
        'stage3.unit2.quant_convbn1': 4,
        'stage3.unit2.quant_act1': 4,
        'stage3.unit2.quant_convbn2': 4,
        'stage3.unit2.quant_act2': 4,
        'stage3.unit2.quant_convbn3': 4,
        'stage3.unit2.quant_act_int32': 16,

        'stage3.unit3.quant_act': 4,
        'stage3.unit3.quant_convbn1': 4,
        'stage3.unit3.quant_act1': 4,
        'stage3.unit3.quant_convbn2': 4,
        'stage3.unit3.quant_act2': 4,
        'stage3.unit3.quant_convbn3': 4,
        'stage3.unit3.quant_act_int32': 16,

        'stage3.unit4.quant_act': 4,
        'stage3.unit4.quant_convbn1': 4,
        'stage3.unit4.quant_act1': 4,
        'stage3.unit4.quant_convbn2': 4,
        'stage3.unit4.quant_act2': 4,
        'stage3.unit4.quant_convbn3': 4,
        'stage3.unit4.quant_act_int32': 16,

        'stage3.unit5.quant_act': 4,
        'stage3.unit5.quant_convbn1': 4,
        'stage3.unit5.quant_act1': 4,
        'stage3.unit5.quant_convbn2': 4,
        'stage3.unit5.quant_act2': 4,
        'stage3.unit5.quant_convbn3': 4,
        'stage3.unit5.quant_act_int32': 16,

        'stage3.unit6.quant_act': 4,
        'stage3.unit6.quant_convbn1': 4,
        'stage3.unit6.quant_act1': 4,
        'stage3.unit6.quant_convbn2': 4,
        'stage3.unit6.quant_act2': 4,
        'stage3.unit6.quant_convbn3': 4,
        'stage3.unit6.quant_act_int32': 16,

        'stage3.unit7.quant_act': 4,
        'stage3.unit7.quant_convbn1': 4,
        'stage3.unit7.quant_act1': 4,
        'stage3.unit7.quant_convbn2': 4,
        'stage3.unit7.quant_act2': 4,
        'stage3.unit7.quant_convbn3': 4,
        'stage3.unit7.quant_act_int32': 16,

        'stage3.unit8.quant_act': 4,
        'stage3.unit8.quant_convbn1': 4,
        'stage3.unit8.quant_act1': 4,
        'stage3.unit8.quant_convbn2': 4,
        'stage3.unit8.quant_act2': 4,
        'stage3.unit8.quant_convbn3': 4,
        'stage3.unit8.quant_act_int32': 16,

        'stage3.unit9.quant_act': 4,
        'stage3.unit9.quant_convbn1': 4,
        'stage3.unit9.quant_act1': 4,
        'stage3.unit9.quant_convbn2': 4,
        'stage3.unit9.quant_act2': 4,
        'stage3.unit9.quant_convbn3': 4,
        'stage3.unit9.quant_act_int32': 16,

        'stage3.unit10.quant_act': 4,
        'stage3.unit10.quant_convbn1': 4,
        'stage3.unit10.quant_act1': 4,
        'stage3.unit10.quant_convbn2': 4,
        'stage3.unit10.quant_act2': 4,
        'stage3.unit10.quant_convbn3': 4,
        'stage3.unit10.quant_act_int32': 16,

        'stage3.unit11.quant_act': 4,
        'stage3.unit11.quant_convbn1': 4,
        'stage3.unit11.quant_act1': 4,
        'stage3.unit11.quant_convbn2': 4,
        'stage3.unit11.quant_act2': 4,
        'stage3.unit11.quant_convbn3': 4,
        'stage3.unit11.quant_act_int32': 16,

        'stage3.unit12.quant_act': 4,
        'stage3.unit12.quant_convbn1': 4,
        'stage3.unit12.quant_act1': 4,
        'stage3.unit12.quant_convbn2': 4,
        'stage3.unit12.quant_act2': 4,
        'stage3.unit12.quant_convbn3': 4,
        'stage3.unit12.quant_act_int32': 16,

        'stage3.unit13.quant_act': 4,
        'stage3.unit13.quant_convbn1': 4,
        'stage3.unit13.quant_act1': 4,
        'stage3.unit13.quant_convbn2': 4,
        'stage3.unit13.quant_act2': 4,
        'stage3.unit13.quant_convbn3': 4,
        'stage3.unit13.quant_act_int32': 16,

        'stage3.unit14.quant_act': 4,
        'stage3.unit14.quant_convbn1': 4,
        'stage3.unit14.quant_act1': 4,
        'stage3.unit14.quant_convbn2': 4,
        'stage3.unit14.quant_act2': 4,
        'stage3.unit14.quant_convbn3': 4,
        'stage3.unit14.quant_act_int32': 16,

        'stage3.unit15.quant_act': 4,
        'stage3.unit15.quant_convbn1': 4,
        'stage3.unit15.quant_act1': 4,
        'stage3.unit15.quant_convbn2': 4,
        'stage3.unit15.quant_act2': 4,
        'stage3.unit15.quant_convbn3': 4,
        'stage3.unit15.quant_act_int32': 16,

        'stage3.unit16.quant_act': 4,
        'stage3.unit16.quant_convbn1': 4,
        'stage3.unit16.quant_act1': 4,
        'stage3.unit16.quant_convbn2': 4,
        'stage3.unit16.quant_act2': 4,
        'stage3.unit16.quant_convbn3': 4,
        'stage3.unit16.quant_act_int32': 16,

        'stage3.unit17.quant_act': 4,
        'stage3.unit17.quant_convbn1': 4,
        'stage3.unit17.quant_act1': 4,
        'stage3.unit17.quant_convbn2': 4,
        'stage3.unit17.quant_act2': 4,
        'stage3.unit17.quant_convbn3': 4,
        'stage3.unit17.quant_act_int32': 16,

        'stage3.unit18.quant_act': 4,
        'stage3.unit18.quant_convbn1': 4,
        'stage3.unit18.quant_act1': 4,
        'stage3.unit18.quant_convbn2': 4,
        'stage3.unit18.quant_act2': 4,
        'stage3.unit18.quant_convbn3': 4,
        'stage3.unit18.quant_act_int32': 16,

        'stage3.unit19.quant_act': 4,
        'stage3.unit19.quant_convbn1': 4,
        'stage3.unit19.quant_act1': 4,
        'stage3.unit19.quant_convbn2': 4,
        'stage3.unit19.quant_act2': 4,
        'stage3.unit19.quant_convbn3': 4,
        'stage3.unit19.quant_act_int32': 16,

        'stage3.unit20.quant_act': 4,
        'stage3.unit20.quant_convbn1': 4,
        'stage3.unit20.quant_act1': 4,
        'stage3.unit20.quant_convbn2': 4,
        'stage3.unit20.quant_act2': 4,
        'stage3.unit20.quant_convbn3': 4,
        'stage3.unit20.quant_act_int32': 16,

        'stage3.unit21.quant_act': 4,
        'stage3.unit21.quant_convbn1': 4,
        'stage3.unit21.quant_act1': 4,
        'stage3.unit21.quant_convbn2': 4,
        'stage3.unit21.quant_act2': 4,
        'stage3.unit21.quant_convbn3': 4,
        'stage3.unit21.quant_act_int32': 16,

        'stage3.unit22.quant_act': 4,
        'stage3.unit22.quant_convbn1': 4,
        'stage3.unit22.quant_act1': 4,
        'stage3.unit22.quant_convbn2': 4,
        'stage3.unit22.quant_act2': 4,
        'stage3.unit22.quant_convbn3': 4,
        'stage3.unit22.quant_act_int32': 16,

        'stage3.unit23.quant_act': 4,
        'stage3.unit23.quant_convbn1': 4,
        'stage3.unit23.quant_act1': 4,
        'stage3.unit23.quant_convbn2': 4,
        'stage3.unit23.quant_act2': 4,
        'stage3.unit23.quant_convbn3': 4,
        'stage3.unit23.quant_act_int32': 16,

        'stage4.unit1.quant_act': 4,
        'stage4.unit1.quant_convbn1': 4,
        'stage4.unit1.quant_act1': 4,
        'stage4.unit1.quant_convbn2': 4,
        'stage4.unit1.quant_act2': 4,
        'stage4.unit1.quant_convbn3': 4,
        'stage4.unit1.quant_identity_convbn': 4,
        'stage4.unit1.quant_act_int32': 16,

        'stage4.unit2.quant_act': 4,
        'stage4.unit2.quant_convbn1': 4,
        'stage4.unit2.quant_act1': 4,
        'stage4.unit2.quant_convbn2': 4,
        'stage4.unit2.quant_act2': 4,
        'stage4.unit2.quant_convbn3': 4,
        'stage4.unit2.quant_act_int32': 16,

        'stage4.unit3.quant_act': 4,
        'stage4.unit3.quant_convbn1': 4,
        'stage4.unit3.quant_act1': 4,
        'stage4.unit3.quant_convbn2': 4,
        'stage4.unit3.quant_act2': 4,
        'stage4.unit3.quant_convbn3': 4,
        'stage4.unit3.quant_act_int32': 16,

        'quant_act_output': 8,
        'quant_output': 8
    },



    "bit_config_inceptionv3_uniform8": {

        'features.q_init_block.q_input_activ': 8,
        'features.q_init_block.q_conv1.q_convbn': 8,
        'features.q_init_block.q_conv1.q_activ': 8,
        'features.q_init_block.q_conv2.q_convbn': 8,
        'features.q_init_block.q_conv2.q_activ': 8,
        'features.q_init_block.q_conv3.q_convbn': 8,
        'features.q_init_block.q_conv3.q_activ': 8,
        'features.q_init_block.q_conv4.q_convbn': 8,
        'features.q_init_block.q_conv4.q_activ': 8,
        'features.q_init_block.q_conv5.q_convbn': 8,
        'features.q_init_block.q_conv5.q_activ': 16,

        'features.stage1.unit1.branches.branch1.q_input_act': 8,
        'features.stage1.unit1.branches.branch1.q_conv.q_convbn': 8,
        'features.stage1.unit1.branches.branch1.q_conv.q_activ': 16,
        'features.stage1.unit1.branches.branch2.q_input_act': 8,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv2.q_activ': 16,
        'features.stage1.unit1.branches.branch3.q_input_act': 8,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv3.q_activ': 16,
        'features.stage1.unit1.branches.branch4.q_input_act': 16,
        'features.stage1.unit1.branches.branch4.q_conv.q_convbn': 8,
        'features.stage1.unit1.branches.branch4.q_pool_act': 8,
        'features.stage1.unit1.branches.branch4.q_conv.q_activ': 16,
        'features.stage1.unit1.q_rescaling_activ': 16,

        'features.stage1.unit2.branches.branch1.q_input_act': (8, 'hook'),
        'features.stage1.unit2.branches.branch1.q_conv.q_convbn': 8,
        'features.stage1.unit2.branches.branch1.q_conv.q_activ': 16,
        'features.stage1.unit2.branches.branch2.q_input_act': 8,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv2.q_activ': 16,
        'features.stage1.unit2.branches.branch3.q_input_act': 8,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv3.q_activ': 16,
        'features.stage1.unit2.branches.branch4.q_input_act': 16,
        'features.stage1.unit2.branches.branch4.q_conv.q_convbn': 8,
        'features.stage1.unit2.branches.branch4.q_pool_act': 8,
        'features.stage1.unit2.branches.branch4.q_conv.q_activ': 16,
        'features.stage1.unit2.q_rescaling_activ': 16,

        'features.stage1.unit3.branches.branch1.q_input_act': 8,
        'features.stage1.unit3.branches.branch1.q_conv.q_convbn': 8,
        'features.stage1.unit3.branches.branch1.q_conv.q_activ': 16,
        'features.stage1.unit3.branches.branch2.q_input_act': 8,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv2.q_activ': 16,
        'features.stage1.unit3.branches.branch3.q_input_act': 8,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv3.q_activ': 16,
        'features.stage1.unit3.branches.branch4.q_input_act': 16,
        'features.stage1.unit3.branches.branch4.q_conv.q_convbn': 8,
        'features.stage1.unit3.branches.branch4.q_pool_act': 8,
        'features.stage1.unit3.branches.branch4.q_conv.q_activ': 16,
        'features.stage1.unit3.q_rescaling_activ': 16,

        'features.stage2.unit1.branches.branch1.q_input_act': 8,
        'features.stage2.unit1.branches.branch1.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit1.branches.branch1.q_conv_list.q_conv1.q_activ': 16,
        'features.stage2.unit1.branches.branch2.q_input_act': 8,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit1.branches.branch3.q_input_act': 16,
        'features.stage2.unit1.q_rescaling_activ': 16,

        'features.stage2.unit2.branches.branch1.q_input_act': 8,
        'features.stage2.unit2.branches.branch1.q_conv.q_convbn': 8,
        'features.stage2.unit2.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit2.branches.branch2.q_input_act': 8,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit2.branches.branch3.q_input_act': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv3.q_activ': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv4.q_convbn': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv4.q_activ': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv5.q_convbn': 8,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit2.branches.branch4.q_input_act': 16,
        'features.stage2.unit2.branches.branch4.q_conv.q_convbn': 8,
        'features.stage2.unit2.branches.branch4.q_pool_act': 8,
        'features.stage2.unit2.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit2.q_rescaling_activ': 16,

        'features.stage2.unit3.branches.branch1.q_input_act': 8,
        'features.stage2.unit3.branches.branch1.q_conv.q_convbn': 8,
        'features.stage2.unit3.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit3.branches.branch2.q_input_act': 8,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit3.branches.branch3.q_input_act': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv3.q_activ': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv4.q_convbn': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv4.q_activ': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv5.q_convbn': 8,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit3.branches.branch4.q_input_act': 16,
        'features.stage2.unit3.branches.branch4.q_conv.q_convbn': 8,
        'features.stage2.unit3.branches.branch4.q_pool_act': 8,
        'features.stage2.unit3.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit3.q_rescaling_activ': 16,

        'features.stage2.unit4.branches.branch1.q_input_act': 8,
        'features.stage2.unit4.branches.branch1.q_conv.q_convbn': 8,
        'features.stage2.unit4.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit4.branches.branch2.q_input_act': 8,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit4.branches.branch3.q_input_act': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv3.q_activ': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv4.q_convbn': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv4.q_activ': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv5.q_convbn': 8,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit4.branches.branch4.q_input_act': 16,
        'features.stage2.unit4.branches.branch4.q_conv.q_convbn': 8,
        'features.stage2.unit4.branches.branch4.q_pool_act': 8,
        'features.stage2.unit4.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit4.q_rescaling_activ': 16,

        'features.stage2.unit5.branches.branch1.q_input_act': 8,
        'features.stage2.unit5.branches.branch1.q_conv.q_convbn': 8,
        'features.stage2.unit5.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit5.branches.branch2.q_input_act': 8,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit5.branches.branch3.q_input_act': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv3.q_activ': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv4.q_convbn': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv4.q_activ': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv5.q_convbn': 8,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit5.branches.branch4.q_input_act': 16,
        'features.stage2.unit5.branches.branch4.q_conv.q_convbn': 8,
        'features.stage2.unit5.branches.branch4.q_pool_act': 8,
        'features.stage2.unit5.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit5.q_rescaling_activ': 16,

        'features.stage3.unit1.branches.branch1.q_input_act': 8,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv1.q_activ': 8,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv2.q_activ': 16,
        'features.stage3.unit1.branches.branch2.q_input_act': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv2.q_activ': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv3.q_convbn': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv3.q_activ': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv4.q_convbn': 8,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv4.q_activ': 16,
        'features.stage3.unit1.branches.branch3.q_input_act': 16,
        'features.stage3.unit1.q_rescaling_activ': 16,

        'features.stage3.unit2.branches.branch1.q_input_act': 8,
        'features.stage3.unit2.branches.branch1.q_conv.q_convbn': 8,
        'features.stage3.unit2.branches.branch1.q_conv.q_activ': 16,
        'features.stage3.unit2.branches.branch2.q_input_act': 8,
        'features.stage3.unit2.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage3.unit2.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage3.unit2.branches.branch2.q_conv1x3.q_convbn': 8,
        'features.stage3.unit2.branches.branch2.q_conv1x3.q_activ': 16,
        'features.stage3.unit2.branches.branch2.q_conv3x1.q_convbn': 8,
        'features.stage3.unit2.branches.branch2.q_conv3x1.q_activ': 16,
        'features.stage3.unit2.branches.branch2.q_rescaling_activ': 16,
        'features.stage3.unit2.branches.branch3.q_input_act': 8,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage3.unit2.branches.branch3.q_conv1x3.q_convbn': 8,
        'features.stage3.unit2.branches.branch3.q_conv1x3.q_activ': 16,
        'features.stage3.unit2.branches.branch3.q_conv3x1.q_convbn': 8,
        'features.stage3.unit2.branches.branch3.q_conv3x1.q_activ': 16,
        'features.stage3.unit2.branches.branch3.q_rescaling_activ': 16,
        'features.stage3.unit2.branches.branch4.q_input_act': 16,
        'features.stage3.unit2.branches.branch4.q_conv.q_convbn': 8,
        'features.stage3.unit2.branches.branch4.q_pool_act': 8,
        'features.stage3.unit2.branches.branch4.q_conv.q_activ': 16,
        'features.stage3.unit2.q_rescaling_activ': 16,

        'features.stage3.unit3.branches.branch1.q_input_act': 8,
        'features.stage3.unit3.branches.branch1.q_conv.q_convbn': 8,
        'features.stage3.unit3.branches.branch1.q_conv.q_activ': 16,
        'features.stage3.unit3.branches.branch2.q_input_act': 8,
        'features.stage3.unit3.branches.branch2.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage3.unit3.branches.branch2.q_conv_list.q_conv1.q_activ': 8,
        'features.stage3.unit3.branches.branch2.q_conv1x3.q_convbn': 8,
        'features.stage3.unit3.branches.branch2.q_conv1x3.q_activ': 16,
        'features.stage3.unit3.branches.branch2.q_conv3x1.q_convbn': 8,
        'features.stage3.unit3.branches.branch2.q_conv3x1.q_activ': 16,
        'features.stage3.unit3.branches.branch2.q_rescaling_activ': 16,
        'features.stage3.unit3.branches.branch3.q_input_act': 8,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv1.q_convbn': 8,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv1.q_activ': 8,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv2.q_convbn': 8,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv2.q_activ': 8,
        'features.stage3.unit3.branches.branch3.q_conv1x3.q_convbn': 8,
        'features.stage3.unit3.branches.branch3.q_conv1x3.q_activ': 16,
        'features.stage3.unit3.branches.branch3.q_conv3x1.q_convbn': 8,
        'features.stage3.unit3.branches.branch3.q_conv3x1.q_activ': 16,
        'features.stage3.unit3.branches.branch3.q_rescaling_activ': 16,
        'features.stage3.unit3.branches.branch4.q_input_act': 16,
        'features.stage3.unit3.branches.branch4.q_conv.q_convbn': 8,
        'features.stage3.unit3.branches.branch4.q_pool_act': 8,
        'features.stage3.unit3.branches.branch4.q_conv.q_activ': 16,
        'features.stage3.unit3.q_rescaling_activ': 16,
        'features.q_concat_activ': 8,
        'output.q_fc': 8
    },

    "bit_config_inceptionv3_uniform4": {

        'features.q_init_block.q_input_activ': (8, 'hook'),
        'features.q_init_block.q_conv1.q_convbn': 8,
        'features.q_init_block.q_conv1.q_activ': 4,
        'features.q_init_block.q_conv2.q_convbn': 4,
        'features.q_init_block.q_conv2.q_activ': 4,
        'features.q_init_block.q_conv3.q_convbn': 4,
        'features.q_init_block.q_conv3.q_activ': 4,
        'features.q_init_block.q_conv4.q_convbn': 4,
        'features.q_init_block.q_conv4.q_activ': 4,
        'features.q_init_block.q_conv5.q_convbn': 4,
        'features.q_init_block.q_conv5.q_activ': 16,

        'features.stage1.unit1.branches.branch1.q_input_act': 4,
        'features.stage1.unit1.branches.branch1.q_conv.q_convbn': 4,
        'features.stage1.unit1.branches.branch1.q_conv.q_activ': 16,
        'features.stage1.unit1.branches.branch2.q_input_act': 4,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage1.unit1.branches.branch2.q_conv_list.q_conv2.q_activ': 16,
        'features.stage1.unit1.branches.branch3.q_input_act': 4,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage1.unit1.branches.branch3.q_conv_list.q_conv3.q_activ': 16,
        'features.stage1.unit1.branches.branch4.q_input_act': 16,
        'features.stage1.unit1.branches.branch4.q_conv.q_convbn': 4,
        'features.stage1.unit1.branches.branch4.q_pool_act': 4,
        'features.stage1.unit1.branches.branch4.q_conv.q_activ': 16,
        'features.stage1.unit1.q_rescaling_activ': 16,

        'features.stage1.unit2.branches.branch1.q_input_act': 4,
        'features.stage1.unit2.branches.branch1.q_conv.q_convbn': 4,
        'features.stage1.unit2.branches.branch1.q_conv.q_activ': 16,
        'features.stage1.unit2.branches.branch2.q_input_act': 4,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage1.unit2.branches.branch2.q_conv_list.q_conv2.q_activ': 16,
        'features.stage1.unit2.branches.branch3.q_input_act': 4,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage1.unit2.branches.branch3.q_conv_list.q_conv3.q_activ': 16,
        'features.stage1.unit2.branches.branch4.q_input_act': 16,
        'features.stage1.unit2.branches.branch4.q_conv.q_convbn': 4,
        'features.stage1.unit2.branches.branch4.q_pool_act': 4,
        'features.stage1.unit2.branches.branch4.q_conv.q_activ': 16,
        'features.stage1.unit2.q_rescaling_activ': 16,

        'features.stage1.unit3.branches.branch1.q_input_act': 4,
        'features.stage1.unit3.branches.branch1.q_conv.q_convbn': 4,
        'features.stage1.unit3.branches.branch1.q_conv.q_activ': 16,
        'features.stage1.unit3.branches.branch2.q_input_act': 4,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage1.unit3.branches.branch2.q_conv_list.q_conv2.q_activ': 16,
        'features.stage1.unit3.branches.branch3.q_input_act': 4,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage1.unit3.branches.branch3.q_conv_list.q_conv3.q_activ': 16,
        'features.stage1.unit3.branches.branch4.q_input_act': 16,
        'features.stage1.unit3.branches.branch4.q_conv.q_convbn': 4,
        'features.stage1.unit3.branches.branch4.q_pool_act': 4,
        'features.stage1.unit3.branches.branch4.q_conv.q_activ': 16,
        'features.stage1.unit3.q_rescaling_activ': 16,

        'features.stage2.unit1.branches.branch1.q_input_act': 4,
        'features.stage2.unit1.branches.branch1.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit1.branches.branch1.q_conv_list.q_conv1.q_activ': 16,
        'features.stage2.unit1.branches.branch2.q_input_act': 4,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit1.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit1.branches.branch3.q_input_act': 16,
        'features.stage2.unit1.q_rescaling_activ': 16,

        'features.stage2.unit2.branches.branch1.q_input_act': 4,
        'features.stage2.unit2.branches.branch1.q_conv.q_convbn': 4,
        'features.stage2.unit2.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit2.branches.branch2.q_input_act': 4,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit2.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit2.branches.branch3.q_input_act': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv3.q_activ': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv4.q_convbn': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv4.q_activ': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv5.q_convbn': 4,
        'features.stage2.unit2.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit2.branches.branch4.q_input_act': 16,
        'features.stage2.unit2.branches.branch4.q_conv.q_convbn': 4,
        'features.stage2.unit2.branches.branch4.q_pool_act': 4,
        'features.stage2.unit2.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit2.q_rescaling_activ': 16,

        'features.stage2.unit3.branches.branch1.q_input_act': 4,
        'features.stage2.unit3.branches.branch1.q_conv.q_convbn': 4,
        'features.stage2.unit3.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit3.branches.branch2.q_input_act': 4,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit3.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit3.branches.branch3.q_input_act': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv3.q_activ': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv4.q_convbn': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv4.q_activ': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv5.q_convbn': 4,
        'features.stage2.unit3.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit3.branches.branch4.q_input_act': 16,
        'features.stage2.unit3.branches.branch4.q_conv.q_convbn': 4,
        'features.stage2.unit3.branches.branch4.q_pool_act': 4,
        'features.stage2.unit3.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit3.q_rescaling_activ': 16,

        'features.stage2.unit4.branches.branch1.q_input_act': 4,
        'features.stage2.unit4.branches.branch1.q_conv.q_convbn': 4,
        'features.stage2.unit4.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit4.branches.branch2.q_input_act': 4,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit4.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit4.branches.branch3.q_input_act': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv3.q_activ': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv4.q_convbn': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv4.q_activ': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv5.q_convbn': 4,
        'features.stage2.unit4.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit4.branches.branch4.q_input_act': 16,
        'features.stage2.unit4.branches.branch4.q_conv.q_convbn': 4,
        'features.stage2.unit4.branches.branch4.q_pool_act': 4,
        'features.stage2.unit4.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit4.q_rescaling_activ': 16,

        'features.stage2.unit5.branches.branch1.q_input_act': 4,
        'features.stage2.unit5.branches.branch1.q_conv.q_convbn': 4,
        'features.stage2.unit5.branches.branch1.q_conv.q_activ': 16,
        'features.stage2.unit5.branches.branch2.q_input_act': 4,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit5.branches.branch2.q_conv_list.q_conv3.q_activ': 16,
        'features.stage2.unit5.branches.branch3.q_input_act': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv3.q_activ': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv4.q_convbn': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv4.q_activ': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv5.q_convbn': 4,
        'features.stage2.unit5.branches.branch3.q_conv_list.q_conv5.q_activ': 16,
        'features.stage2.unit5.branches.branch4.q_input_act': 16,
        'features.stage2.unit5.branches.branch4.q_conv.q_convbn': 4,
        'features.stage2.unit5.branches.branch4.q_pool_act': 4,
        'features.stage2.unit5.branches.branch4.q_conv.q_activ': 16,
        'features.stage2.unit5.q_rescaling_activ': 16,

        'features.stage3.unit1.branches.branch1.q_input_act': 4,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv1.q_activ': 4,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage3.unit1.branches.branch1.q_conv_list.q_conv2.q_activ': 16,
        'features.stage3.unit1.branches.branch2.q_input_act': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv2.q_activ': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv3.q_convbn': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv3.q_activ': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv4.q_convbn': 4,
        'features.stage3.unit1.branches.branch2.q_conv_list.q_conv4.q_activ': 16,
        'features.stage3.unit1.branches.branch3.q_input_act': 16,
        'features.stage3.unit1.q_rescaling_activ': 16,

        'features.stage3.unit2.branches.branch1.q_input_act': 4,
        'features.stage3.unit2.branches.branch1.q_conv.q_convbn': 4,
        'features.stage3.unit2.branches.branch1.q_conv.q_activ': 16,
        'features.stage3.unit2.branches.branch2.q_input_act': 4,
        'features.stage3.unit2.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage3.unit2.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage3.unit2.branches.branch2.q_conv1x3.q_convbn': 4,
        'features.stage3.unit2.branches.branch2.q_conv1x3.q_activ': 16,
        'features.stage3.unit2.branches.branch2.q_conv3x1.q_convbn': 4,
        'features.stage3.unit2.branches.branch2.q_conv3x1.q_activ': 16,
        'features.stage3.unit2.branches.branch2.q_rescaling_activ': 16,
        'features.stage3.unit2.branches.branch3.q_input_act': 4,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage3.unit2.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage3.unit2.branches.branch3.q_conv1x3.q_convbn': 4,
        'features.stage3.unit2.branches.branch3.q_conv1x3.q_activ': 16,
        'features.stage3.unit2.branches.branch3.q_conv3x1.q_convbn': 4,
        'features.stage3.unit2.branches.branch3.q_conv3x1.q_activ': 16,
        'features.stage3.unit2.branches.branch3.q_rescaling_activ': 16,
        'features.stage3.unit2.branches.branch4.q_input_act': 16,
        'features.stage3.unit2.branches.branch4.q_conv.q_convbn': 4,
        'features.stage3.unit2.branches.branch4.q_pool_act': 4,
        'features.stage3.unit2.branches.branch4.q_conv.q_activ': 16,
        'features.stage3.unit2.q_rescaling_activ': 16,

        'features.stage3.unit3.branches.branch1.q_input_act': 4,
        'features.stage3.unit3.branches.branch1.q_conv.q_convbn': 4,
        'features.stage3.unit3.branches.branch1.q_conv.q_activ': 16,
        'features.stage3.unit3.branches.branch2.q_input_act': 4,
        'features.stage3.unit3.branches.branch2.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage3.unit3.branches.branch2.q_conv_list.q_conv1.q_activ': 4,
        'features.stage3.unit3.branches.branch2.q_conv1x3.q_convbn': 4,
        'features.stage3.unit3.branches.branch2.q_conv1x3.q_activ': 16,
        'features.stage3.unit3.branches.branch2.q_conv3x1.q_convbn': 4,
        'features.stage3.unit3.branches.branch2.q_conv3x1.q_activ': 16,
        'features.stage3.unit3.branches.branch2.q_rescaling_activ': 16,
        'features.stage3.unit3.branches.branch3.q_input_act': 4,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv1.q_convbn': 4,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv1.q_activ': 4,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv2.q_convbn': 4,
        'features.stage3.unit3.branches.branch3.q_conv_list.q_conv2.q_activ': 4,
        'features.stage3.unit3.branches.branch3.q_conv1x3.q_convbn': 4,
        'features.stage3.unit3.branches.branch3.q_conv1x3.q_activ': 16,
        'features.stage3.unit3.branches.branch3.q_conv3x1.q_convbn': 4,
        'features.stage3.unit3.branches.branch3.q_conv3x1.q_activ': 16,
        'features.stage3.unit3.branches.branch3.q_rescaling_activ': 16,
        'features.stage3.unit3.branches.branch4.q_input_act': 16,
        'features.stage3.unit3.branches.branch4.q_conv.q_convbn': 4,
        'features.stage3.unit3.branches.branch4.q_pool_act': 4,
        'features.stage3.unit3.branches.branch4.q_conv.q_activ': 16,
        'features.stage3.unit3.q_rescaling_activ': 16,
        'features.q_concat_activ': 8,
        'output.q_fc': 8
    },



    "bit_config_mobilenetv2_w1_uniform8": {

        "quant_input": (8, 'hook'),
        "init_block": 8,
        "quant_act_int32": 16,

        "features.stage1.unit1.quant_act": 8,
        "features.stage1.unit1.conv1": 8,
        "features.stage1.unit1.quant_act1": 8,
        "features.stage1.unit1.conv2": 8,
        "features.stage1.unit1.quant_act2": 8,
        "features.stage1.unit1.conv3": 8,
        "features.stage1.unit1.quant_act_int32": 16,

        "features.stage2.unit1.quant_act": 8,
        "features.stage2.unit1.conv1": 8,
        "features.stage2.unit1.quant_act1": 8,
        "features.stage2.unit1.conv2": 8,
        "features.stage2.unit1.quant_act2": 8,
        "features.stage2.unit1.conv3": 8,
        "features.stage2.unit1.quant_act_int32": 16,

        "features.stage2.unit2.quant_act": 8,
        "features.stage2.unit2.conv1": 8,
        "features.stage2.unit2.quant_act1": 8,
        "features.stage2.unit2.conv2": 8,
        "features.stage2.unit2.quant_act2": 8,
        "features.stage2.unit2.conv3": 8,
        "features.stage2.unit2.quant_act_int32": 16,

        "features.stage3.unit1.quant_act": 8,
        "features.stage3.unit1.conv1": 8,
        "features.stage3.unit1.quant_act1": 8,
        "features.stage3.unit1.conv2": 8,
        "features.stage3.unit1.quant_act2": 8,
        "features.stage3.unit1.conv3": 8,
        "features.stage3.unit1.quant_act_int32": 16,

        "features.stage3.unit2.quant_act": 8,
        "features.stage3.unit2.conv1": 8,
        "features.stage3.unit2.quant_act1": 8,
        "features.stage3.unit2.conv2": 8,
        "features.stage3.unit2.quant_act2": 8,
        "features.stage3.unit2.conv3": 8,
        "features.stage3.unit2.quant_act_int32": 16,

        "features.stage3.unit3.quant_act": 8,
        "features.stage3.unit3.conv1": 8,
        "features.stage3.unit3.quant_act1": 8,
        "features.stage3.unit3.conv2": 8,
        "features.stage3.unit3.quant_act2": 8,
        "features.stage3.unit3.conv3": 8,
        "features.stage3.unit3.quant_act_int32": 16,

        "features.stage4.unit1.quant_act": 8,
        "features.stage4.unit1.conv1": 8,
        "features.stage4.unit1.quant_act1": 8,
        "features.stage4.unit1.conv2": 8,
        "features.stage4.unit1.quant_act2": 8,
        "features.stage4.unit1.conv3": 8,
        "features.stage4.unit1.quant_act_int32": 16,

        "features.stage4.unit2.quant_act": 8,
        "features.stage4.unit2.conv1": 8,
        "features.stage4.unit2.quant_act1": 8,
        "features.stage4.unit2.conv2": 8,
        "features.stage4.unit2.quant_act2": 8,
        "features.stage4.unit2.conv3": 8,
        "features.stage4.unit2.quant_act_int32": 16,

        "features.stage4.unit3.quant_act": 8,
        "features.stage4.unit3.conv1": 8,
        "features.stage4.unit3.quant_act1": 8,
        "features.stage4.unit3.conv2": 8,
        "features.stage4.unit3.quant_act2": 8,
        "features.stage4.unit3.conv3": 8,
        "features.stage4.unit3.quant_act_int32": 16,

        "features.stage4.unit4.quant_act": 8,
        "features.stage4.unit4.conv1": 8,
        "features.stage4.unit4.quant_act1": 8,
        "features.stage4.unit4.conv2": 8,
        "features.stage4.unit4.quant_act2": 8,
        "features.stage4.unit4.conv3": 8,
        "features.stage4.unit4.quant_act_int32": 16,

        "features.stage4.unit5.quant_act": 8,
        "features.stage4.unit5.conv1": 8,
        "features.stage4.unit5.conv1.conv": 8,
        "features.stage4.unit5.conv1.bn": 8,
        "features.stage4.unit5.quant_act1": 8,
        "features.stage4.unit5.conv2": 8,
        "features.stage4.unit5.quant_act2": 8,
        "features.stage4.unit5.conv3": 8,
        "features.stage4.unit5.quant_act_int32": 16,

        "features.stage4.unit6.quant_act": 8,
        "features.stage4.unit6.conv1": 8,
        "features.stage4.unit6.quant_act1": 8,
        "features.stage4.unit6.conv2": 8,
        "features.stage4.unit6.quant_act2": 8,
        "features.stage4.unit6.conv3": 8,
        "features.stage4.unit6.quant_act_int32": 16,

        "features.stage4.unit7.quant_act": 8,
        "features.stage4.unit7.conv1": 8,
        "features.stage4.unit7.quant_act1": 8,
        "features.stage4.unit7.conv2": 8,
        "features.stage4.unit7.quant_act2": 8,
        "features.stage4.unit7.conv3": 8,
        "features.stage4.unit7.quant_act_int32": 16,

        "features.stage5.unit1.quant_act": 8,
        "features.stage5.unit1.conv1": 8,
        "features.stage5.unit1.quant_act1": 8,
        "features.stage5.unit1.conv2": 8,
        "features.stage5.unit1.quant_act2": 8,
        "features.stage5.unit1.conv3": 8,
        "features.stage5.unit1.quant_act_int32": 16,

        "features.stage5.unit2.quant_act": 8,
        "features.stage5.unit2.conv1": 8,
        "features.stage5.unit2.quant_act1": 8,
        "features.stage5.unit2.conv2": 8,
        "features.stage5.unit2.quant_act2": 8,
        "features.stage5.unit2.conv3": 8,
        "features.stage5.unit2.quant_act_int32": 16,

        "features.stage5.unit3.quant_act": 8,
        "features.stage5.unit3.conv1": 8,
        "features.stage5.unit3.quant_act1": 8,
        "features.stage5.unit3.conv2": 8,
        "features.stage5.unit3.quant_act2": 8,
        "features.stage5.unit3.conv3": 8,
        "features.stage5.unit3.quant_act_int32": 16,

        "features.stage5.unit4.quant_act": 8,
        "features.stage5.unit4.conv1": 8,
        "features.stage5.unit4.quant_act1": 8,
        "features.stage5.unit4.conv2": 8,
        "features.stage5.unit4.quant_act2": 8,
        "features.stage5.unit4.conv3": 8,
        "features.stage5.unit4.quant_act_int32": 16,

        "quant_act_before_final_block": 8,
        "features.final_block": 8,
        "quant_act_int32_final": 16,
        "quant_act_output": 8,
        "output": 8,
    },

    "bit_config_mobilenetv2_w1_modelsize_0.5": {

        "quant_input": 8,
        "init_block": 8,
        "quant_act_int32": 16,

        "features.stage1.unit1.quant_act": 8,
        "features.stage1.unit1.conv1": 8,
        "features.stage1.unit1.quant_act1": 8,
        "features.stage1.unit1.conv2": 8,
        "features.stage1.unit1.quant_act2": 8,
        "features.stage1.unit1.conv3": 8,
        "features.stage1.unit1.quant_act_int32": 16,

        "features.stage2.unit1.quant_act": 8,
        "features.stage2.unit1.conv1": 8,
        "features.stage2.unit1.quant_act1": 8,
        "features.stage2.unit1.conv2": 8,
        "features.stage2.unit1.quant_act2": 8,
        "features.stage2.unit1.conv3": 8,
        "features.stage2.unit1.quant_act_int32": 16,

        "features.stage2.unit2.quant_act": 8,
        "features.stage2.unit2.conv1": 8,
        "features.stage2.unit2.quant_act1": 8,
        "features.stage2.unit2.conv2": 8,
        "features.stage2.unit2.quant_act2": 8,
        "features.stage2.unit2.conv3": 8,
        "features.stage2.unit2.quant_act_int32": 16,

        "features.stage3.unit1.quant_act": 8,
        "features.stage3.unit1.conv1": 8,
        "features.stage3.unit1.quant_act1": 8,
        "features.stage3.unit1.conv2": 8,
        "features.stage3.unit1.quant_act2": 8,
        "features.stage3.unit1.conv3": 8,
        "features.stage3.unit1.quant_act_int32": 16,

        "features.stage3.unit2.quant_act": 4,
        "features.stage3.unit2.conv1": 4,
        "features.stage3.unit2.quant_act1": 8,
        "features.stage3.unit2.conv2": 8,
        "features.stage3.unit2.quant_act2": 8,
        "features.stage3.unit2.conv3": 8,
        "features.stage3.unit2.quant_act_int32": 16,

        "features.stage3.unit3.quant_act": 4,
        "features.stage3.unit3.conv1": 4,
        "features.stage3.unit3.quant_act1": 8,
        "features.stage3.unit3.conv2": 8,
        "features.stage3.unit3.quant_act2": 8,
        "features.stage3.unit3.conv3": 8,
        "features.stage3.unit3.quant_act_int32": 16,

        "features.stage4.unit1.quant_act": 8,
        "features.stage4.unit1.conv1": 8,
        "features.stage4.unit1.quant_act1": 8,
        "features.stage4.unit1.conv2": 8,
        "features.stage4.unit1.quant_act2": 8,
        "features.stage4.unit1.conv3": 8,
        "features.stage4.unit1.quant_act_int32": 16,

        "features.stage4.unit2.quant_act": 4,
        "features.stage4.unit2.conv1": 4,
        "features.stage4.unit2.quant_act1": 8,
        "features.stage4.unit2.conv2": 8,
        "features.stage4.unit2.quant_act2": 4,
        "features.stage4.unit2.conv3": 4,
        "features.stage4.unit2.quant_act_int32": 16,

        "features.stage4.unit3.quant_act": 4,
        "features.stage4.unit3.conv1": 4,
        "features.stage4.unit3.quant_act1": 8,
        "features.stage4.unit3.conv2": 8,
        "features.stage4.unit3.quant_act2": 4,
        "features.stage4.unit3.conv3": 4,
        "features.stage4.unit3.quant_act_int32": 16,

        "features.stage4.unit4.quant_act": 4,
        "features.stage4.unit4.conv1": 4,
        "features.stage4.unit4.quant_act1": 8,
        "features.stage4.unit4.conv2": 8,
        "features.stage4.unit4.quant_act2": 4,
        "features.stage4.unit4.conv3": 4,
        "features.stage4.unit4.quant_act_int32": 16,

        "features.stage4.unit5.quant_act": 8,
        "features.stage4.unit5.conv1": 8,
        "features.stage4.unit5.quant_act1": 8,
        "features.stage4.unit5.conv2": 8,
        "features.stage4.unit5.quant_act2": 8,
        "features.stage4.unit5.conv3": 8,
        "features.stage4.unit5.quant_act_int32": 16,

        "features.stage4.unit6.quant_act": 4,
        "features.stage4.unit6.conv1": 4,
        "features.stage4.unit6.quant_act1": 8,
        "features.stage4.unit6.conv2": 8,
        "features.stage4.unit6.quant_act2": 4,
        "features.stage4.unit6.conv3": 4,
        "features.stage4.unit6.quant_act_int32": 16,

        "features.stage4.unit7.quant_act": 4,
        "features.stage4.unit7.conv1": 4,
        "features.stage4.unit7.quant_act1": 8,
        "features.stage4.unit7.conv2": 8,
        "features.stage4.unit7.quant_act2": 4,
        "features.stage4.unit7.conv3": 4,
        "features.stage4.unit7.quant_act_int32": 16,

        "features.stage5.unit1.quant_act": 8,
        "features.stage5.unit1.conv1": 8,
        "features.stage5.unit1.quant_act1": 8,
        "features.stage5.unit1.conv2": 8,
        "features.stage5.unit1.quant_act2": 8,
        "features.stage5.unit1.conv3": 8,
        "features.stage5.unit1.quant_act_int32": 16,

        "features.stage5.unit2.quant_act": 4,
        "features.stage5.unit2.conv1": 4,
        "features.stage5.unit2.quant_act1": 8,
        "features.stage5.unit2.conv2": 8,
        "features.stage5.unit2.quant_act2": 4,
        "features.stage5.unit2.conv3": 4,
        "features.stage5.unit2.quant_act_int32": 16,

        "features.stage5.unit3.quant_act": 8,
        "features.stage5.unit3.conv1": 8,
        "features.stage5.unit3.quant_act1": 8,
        "features.stage5.unit3.conv2": 8,
        "features.stage5.unit3.quant_act2": 8,
        "features.stage5.unit3.conv3": 8,
        "features.stage5.unit3.quant_act_int32": 16,

        "features.stage5.unit4.quant_act": 8,
        "features.stage5.unit4.conv1": 8,
        "features.stage5.unit4.quant_act1": 8,
        "features.stage5.unit4.conv2": 8,
        "features.stage5.unit4.quant_act2": 8,
        "features.stage5.unit4.conv3": 8,
        "features.stage5.unit4.quant_act_int32": 16,

        "quant_act_before_final_block": 8,
        "features.final_block": 8,
        "quant_act_int32_final": 16,
        "quant_act_output": 8,
        "output": 8,
    },

    "bit_config_mobilenetv2_w1_bops_0.5": {

        "quant_input": 8,
        "init_block": 8,
        "quant_act_int32": 16,

        "features.stage1.unit1.quant_act": 8,
        "features.stage1.unit1.conv1": 8,
        "features.stage1.unit1.quant_act1": 8,
        "features.stage1.unit1.conv2": 8,
        "features.stage1.unit1.quant_act2": 8,
        "features.stage1.unit1.conv3": 8,
        "features.stage1.unit1.quant_act_int32": 16,

        "features.stage2.unit1.quant_act": 4,
        "features.stage2.unit1.conv1": 4,
        "features.stage2.unit1.quant_act1": 8,
        "features.stage2.unit1.conv2": 8,
        "features.stage2.unit1.quant_act2": 8,
        "features.stage2.unit1.conv3": 8,
        "features.stage2.unit1.quant_act_int32": 16,

        "features.stage2.unit2.quant_act": 4,
        "features.stage2.unit2.conv1": 4,
        "features.stage2.unit2.quant_act1": 8,
        "features.stage2.unit2.conv2": 8,
        "features.stage2.unit2.quant_act2": 8,
        "features.stage2.unit2.conv3": 8,
        "features.stage2.unit2.quant_act_int32": 16,

        "features.stage3.unit1.quant_act": 4,
        "features.stage3.unit1.conv1": 4,
        "features.stage3.unit1.quant_act1": 8,
        "features.stage3.unit1.conv2": 8,
        "features.stage3.unit1.quant_act2": 8,
        "features.stage3.unit1.conv3": 8,
        "features.stage3.unit1.quant_act_int32": 16,

        "features.stage3.unit2.quant_act": 4,
        "features.stage3.unit2.conv1": 4,
        "features.stage3.unit2.quant_act1": 8,
        "features.stage3.unit2.conv2": 8,
        "features.stage3.unit2.quant_act2": 8,
        "features.stage3.unit2.conv3": 8,
        "features.stage3.unit2.quant_act_int32": 16,

        "features.stage3.unit3.quant_act": 4,
        "features.stage3.unit3.conv1": 4,
        "features.stage3.unit3.quant_act1": 8,
        "features.stage3.unit3.conv2": 8,
        "features.stage3.unit3.quant_act2": 8,
        "features.stage3.unit3.conv3": 8,
        "features.stage3.unit3.quant_act_int32": 16,

        "features.stage4.unit1.quant_act": 8,
        "features.stage4.unit1.conv1": 8,
        "features.stage4.unit1.quant_act1": 8,
        "features.stage4.unit1.conv2": 8,
        "features.stage4.unit1.quant_act2": 8,
        "features.stage4.unit1.conv3": 8,
        "features.stage4.unit1.quant_act_int32": 16,

        "features.stage4.unit2.quant_act": 4,
        "features.stage4.unit2.conv1": 4,
        "features.stage4.unit2.quant_act1": 8,
        "features.stage4.unit2.conv2": 8,
        "features.stage4.unit2.quant_act2": 8,
        "features.stage4.unit2.conv3": 8,
        "features.stage4.unit2.quant_act_int32": 16,

        "features.stage4.unit3.quant_act": 4,
        "features.stage4.unit3.conv1": 4,
        "features.stage4.unit3.quant_act1": 8,
        "features.stage4.unit3.conv2": 8,
        "features.stage4.unit3.quant_act2": 4,
        "features.stage4.unit3.conv3": 4,
        "features.stage4.unit3.quant_act_int32": 16,

        "features.stage4.unit4.quant_act": 4,
        "features.stage4.unit4.conv1": 4,
        "features.stage4.unit4.quant_act1": 8,
        "features.stage4.unit4.conv2": 8,
        "features.stage4.unit4.quant_act2": 4,
        "features.stage4.unit4.conv3": 4,
        "features.stage4.unit4.quant_act_int32": 16,

        "features.stage4.unit5.quant_act": 8,
        "features.stage4.unit5.conv1": 8,
        "features.stage4.unit5.conv1.conv": 8,
        "features.stage4.unit5.conv1.bn": 8,
        "features.stage4.unit5.quant_act1": 8,
        "features.stage4.unit5.conv2": 8,
        "features.stage4.unit5.quant_act2": 8,
        "features.stage4.unit5.conv3": 8,
        "features.stage4.unit5.quant_act_int32": 16,

        "features.stage4.unit6.quant_act": 4,
        "features.stage4.unit6.conv1": 4,
        "features.stage4.unit6.quant_act1": 8,
        "features.stage4.unit6.conv2": 8,
        "features.stage4.unit6.quant_act2": 4,
        "features.stage4.unit6.conv3": 4,
        "features.stage4.unit6.quant_act_int32": 16,

        "features.stage4.unit7.quant_act": 4,
        "features.stage4.unit7.conv1": 4,
        "features.stage4.unit7.quant_act1": 8,
        "features.stage4.unit7.conv2": 8,
        "features.stage4.unit7.quant_act2": 8,
        "features.stage4.unit7.conv3": 8,
        "features.stage4.unit7.quant_act_int32": 16,

        "features.stage5.unit1.quant_act": 4,
        "features.stage5.unit1.conv1": 4,
        "features.stage5.unit1.quant_act1": 8,
        "features.stage5.unit1.conv2": 8,
        "features.stage5.unit1.quant_act2": 8,
        "features.stage5.unit1.conv3": 8,
        "features.stage5.unit1.quant_act_int32": 16,

        "features.stage5.unit2.quant_act": 4,
        "features.stage5.unit2.conv1": 4,
        "features.stage5.unit2.quant_act1": 8,
        "features.stage5.unit2.conv2": 8,
        "features.stage5.unit2.quant_act2": 8,
        "features.stage5.unit2.conv3": 8,
        "features.stage5.unit2.quant_act_int32": 16,

        "features.stage5.unit3.quant_act": 4,
        "features.stage5.unit3.conv1": 4,
        "features.stage5.unit3.quant_act1": 8,
        "features.stage5.unit3.conv2": 8,
        "features.stage5.unit3.quant_act2": 8,
        "features.stage5.unit3.conv3": 8,
        "features.stage5.unit3.quant_act_int32": 16,

        "features.stage5.unit4.quant_act": 4,
        "features.stage5.unit4.conv1": 4,
        "features.stage5.unit4.quant_act1": 4,
        "features.stage5.unit4.conv2": 4,
        "features.stage5.unit4.quant_act2": 8,
        "features.stage5.unit4.conv3": 8,
        "features.stage5.unit4.quant_act_int32": 16,

        "quant_act_before_final_block": 8,
        "features.final_block": 8,
        "quant_act_int32_final": 16,
        "quant_act_output": 8,
        "output": 8,
    },

    "bit_config_mobilenetv2_w1_uniform4": {

        "quant_input": (8, 'hook'),
        "init_block": 8,
        "quant_act_int32": 16,

        "features.stage1.unit1.quant_act": 4,
        "features.stage1.unit1.conv1": 4,
        "features.stage1.unit1.quant_act1": 4,
        "features.stage1.unit1.conv2": 4,
        "features.stage1.unit1.quant_act2": 4,
        "features.stage1.unit1.conv3": 4,
        "features.stage1.unit1.quant_act_int32": 16,

        "features.stage2.unit1.quant_act": 4,
        "features.stage2.unit1.conv1": 4,
        "features.stage2.unit1.quant_act1": 4,
        "features.stage2.unit1.conv2": 4,
        "features.stage2.unit1.quant_act2": 4,
        "features.stage2.unit1.conv3": 4,
        "features.stage2.unit1.quant_act_int32": 16,

        "features.stage2.unit2.quant_act": 4,
        "features.stage2.unit2.conv1": 4,
        "features.stage2.unit2.quant_act1": 4,
        "features.stage2.unit2.conv2": 4,
        "features.stage2.unit2.quant_act2": 4,
        "features.stage2.unit2.conv3": 4,
        "features.stage2.unit2.quant_act_int32": 16,

        "features.stage3.unit1.quant_act": 4,
        "features.stage3.unit1.conv1": 4,
        "features.stage3.unit1.quant_act1": 4,
        "features.stage3.unit1.conv2": 4,
        "features.stage3.unit1.quant_act2": 4,
        "features.stage3.unit1.conv3": 4,
        "features.stage3.unit1.quant_act_int32": 16,

        "features.stage3.unit2.quant_act": 4,
        "features.stage3.unit2.conv1": 4,
        "features.stage3.unit2.quant_act1": 4,
        "features.stage3.unit2.conv2": 4,
        "features.stage3.unit2.quant_act2": 4,
        "features.stage3.unit2.conv3": 4,
        "features.stage3.unit2.quant_act_int32": 16,

        "features.stage3.unit3.quant_act": 4,
        "features.stage3.unit3.conv1": 4,
        "features.stage3.unit3.quant_act1": 4,
        "features.stage3.unit3.conv2": 4,
        "features.stage3.unit3.quant_act2": 4,
        "features.stage3.unit3.conv3": 4,
        "features.stage3.unit3.quant_act_int32": 16,

        "features.stage4.unit1.quant_act": 4,
        "features.stage4.unit1.conv1": 4,
        "features.stage4.unit1.quant_act1": 4,
        "features.stage4.unit1.conv2": 4,
        "features.stage4.unit1.quant_act2": 4,
        "features.stage4.unit1.conv3": 4,
        "features.stage4.unit1.quant_act_int32": 16,

        "features.stage4.unit2.quant_act": 4,
        "features.stage4.unit2.conv1": 4,
        "features.stage4.unit2.quant_act1": 4,
        "features.stage4.unit2.conv2": 4,
        "features.stage4.unit2.quant_act2": 4,
        "features.stage4.unit2.conv3": 4,
        "features.stage4.unit2.quant_act_int32": 16,

        "features.stage4.unit3.quant_act": 4,
        "features.stage4.unit3.conv1": 4,
        "features.stage4.unit3.quant_act1": 4,
        "features.stage4.unit3.conv2": 4,
        "features.stage4.unit3.quant_act2": 4,
        "features.stage4.unit3.conv3": 4,
        "features.stage4.unit3.quant_act_int32": 16,

        "features.stage4.unit4.quant_act": 4,
        "features.stage4.unit4.conv1": 4,
        "features.stage4.unit4.quant_act1": 4,
        "features.stage4.unit4.conv2": 4,
        "features.stage4.unit4.quant_act2": 4,
        "features.stage4.unit4.conv3": 4,
        "features.stage4.unit4.quant_act_int32": 16,

        "features.stage4.unit5.quant_act": 4,
        "features.stage4.unit5.conv1": 4,
        "features.stage4.unit5.conv1.conv": 4,
        "features.stage4.unit5.conv1.bn": 4,
        "features.stage4.unit5.quant_act1": 4,
        "features.stage4.unit5.conv2": 4,
        "features.stage4.unit5.quant_act2": 4,
        "features.stage4.unit5.conv3": 4,
        "features.stage4.unit5.quant_act_int32": 16,

        "features.stage4.unit6.quant_act": 4,
        "features.stage4.unit6.conv1": 4,
        "features.stage4.unit6.quant_act1": 4,
        "features.stage4.unit6.conv2": 4,
        "features.stage4.unit6.quant_act2": 4,
        "features.stage4.unit6.conv3": 4,
        "features.stage4.unit6.quant_act_int32": 16,

        "features.stage4.unit7.quant_act": 4,
        "features.stage4.unit7.conv1": 4,
        "features.stage4.unit7.quant_act1": 4,
        "features.stage4.unit7.conv2": 4,
        "features.stage4.unit7.quant_act2": 4,
        "features.stage4.unit7.conv3": 4,
        "features.stage4.unit7.quant_act_int32": 16,

        "features.stage5.unit1.quant_act": 4,
        "features.stage5.unit1.conv1": 4,
        "features.stage5.unit1.quant_act1": 4,
        "features.stage5.unit1.conv2": 4,
        "features.stage5.unit1.quant_act2": 4,
        "features.stage5.unit1.conv3": 4,
        "features.stage5.unit1.quant_act_int32": 16,

        "features.stage5.unit2.quant_act": 4,
        "features.stage5.unit2.conv1": 4,
        "features.stage5.unit2.quant_act1": 4,
        "features.stage5.unit2.conv2": 4,
        "features.stage5.unit2.quant_act2": 4,
        "features.stage5.unit2.conv3": 4,
        "features.stage5.unit2.quant_act_int32": 16,

        "features.stage5.unit3.quant_act": 4,
        "features.stage5.unit3.conv1": 4,
        "features.stage5.unit3.quant_act1": 4,
        "features.stage5.unit3.conv2": 4,
        "features.stage5.unit3.quant_act2": 4,
        "features.stage5.unit3.conv3": 4,
        "features.stage5.unit3.quant_act_int32": 16,

        "features.stage5.unit4.quant_act": 4,
        "features.stage5.unit4.conv1": 4,
        "features.stage5.unit4.quant_act1": 4,
        "features.stage5.unit4.conv2": 4,
        "features.stage5.unit4.quant_act2": 4,
        "features.stage5.unit4.conv3": 4,
        "features.stage5.unit4.quant_act_int32": 16,

        "quant_act_before_final_block": 8,
        "features.final_block": 8,
        "quant_act_int32_final": 16,
        "quant_act_output": 8,
        "output": 8,
    },

}


def read_ILPbit_config_dict_json(json_path):
    # 读取json文件并输出
    with open(json_path, 'r') as dic:
        dic_str = json.load(dic)
    # print("\n读取 ILP bit_config_dict  JSON格式文件的内容 并转换为字典：\n{}".format(dic_str))
    return dic_str
